//****************************************************************************//
//   P3.cpp - Einblick in die Tasten- und Zeichenmessages                     //
//****************************************************************************//
#include <windows.h>
#include <stdio.h>

#define BLANK ' '

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunction, die die Messages der Client-Area verarbeitet //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// Globale Variablen                                                          //
//----------------------------------------------------------------------------//

RECT rect;
int  cxChar;
int  cyChar;
char szTop[] = "Botschaft      Taste Zeichen  Wdh.  OEM-Code Erw. ALT   vorher"
               " jetzt";
char szUnd[] = "_________      _____ _______ ______ ________ ____ ___   ______"
					" ________";

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdParam,
                    int nCmdShow)
{
   //-------------------------------------------------------------------------//
	// Hier wieder die vier unverzichtbaren Variablen...                       //
   //-------------------------------------------------------------------------//
	static char szWindowclassname [] = "P3";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWindowclass;

   if (!hPrevInstance)
   {
   	aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = szWindowclassname;

	   RegisterClass (&aWindowclass);
   }

   //-------------------------------------------------------------------------//
	// Fenster erzeugen und anzeigen                                           //
   //-------------------------------------------------------------------------//
   hWindow = CreateWindow (szWindowclassname, "Tastaturereignisse",
                           WS_OVERLAPPEDWINDOW,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							NULL, NULL, hInstance, NULL);
	ShowWindow   (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   //-------------------------------------------------------------------------//
	// Verarbeiten aller Botschaften an unser Programm                         //
   //-------------------------------------------------------------------------//
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
   	TranslateMessage (&aMessage);
      DispatchMessage  (&aMessage);
   }
   //-------------------------------------------------------------------------//
	// Windowskernel mitteilen, da die WM_QUIT-Message verarbeitet wurde      //
   //-------------------------------------------------------------------------//
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Diese Routine wird bei jeder CHAR-Botschaft bentigt und ist daher ver-    //
// allgemeinert und ausgelagert                                               //
//----------------------------------------------------------------------------//
void ShowKey (HWND hwnd, char *szMessage, UINT wParam, LONG lParam)
{
	//-------------------------------------------------------------------------//
	// Formatstring des Ausgabetextes und andere Textkonstanten                //
	//-------------------------------------------------------------------------//
	static char *szFormat = {"%-14s %5d    %c %8u %9d %3s %3s %9s %8s"};
   static char szUp   [] = "gelst";
   static char szDown [] = "gedrckt";

	//-------------------------------------------------------------------------//
   // Stringpuffer fr die Aufbereitung des Ausgabestrings                    //
	//-------------------------------------------------------------------------//
	char        szBuffer[90];
   int         nTextlen;
   HDC         hdc;

	//-------------------------------------------------------------------------//
	// Fenster um eine Zeile nach oben scrollen                                //
	//-------------------------------------------------------------------------//
   ScrollWindow (hwnd, 0, -cyChar, &rect, &rect);

	//-------------------------------------------------------------------------//
	// Systemfont zur Textausgabe heranziehen                                  //
	//-------------------------------------------------------------------------//
   hdc = GetDC (hwnd);
   SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT));

	//-------------------------------------------------------------------------//
	// Text aufbereiten                                                        //
	//-------------------------------------------------------------------------//
   nTextlen = wsprintf (szBuffer, szFormat,
                        (LPSTR) szMessage, wParam,
                        (BYTE)  wParam,
                        LOWORD (lParam),
                        HIWORD (lParam) & 0xFF,
                        (LPSTR) (0x01000000 & lParam ? " * "  : ""),
                        (LPSTR) (0x20000000 & lParam ? " * "  : ""),
                        (LPSTR) (0x40000000 & lParam ? szDown : szUp),
                        (LPSTR) (0x80000000 & lParam ? szUp : szDown));

	//-------------------------------------------------------------------------//
	// Text in der untersten Zeile ausgeben                                    //
	//-------------------------------------------------------------------------//
   TextOut (hdc, cxChar, rect.bottom - cyChar, szBuffer, nTextlen);
   ReleaseDC (hwnd, hdc);

	//-------------------------------------------------------------------------//
	// Windows bescheid geben, da der Bereich nicht neu gezeichnet werden mu //
	//-------------------------------------------------------------------------//
	ValidateRect (hwnd, NULL);
}

//----------------------------------------------------------------------------//
// Messagehandler der Client-Area                                             //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   HDC         hdc;
   PAINTSTRUCT ps;
   TEXTMETRIC  tm;

   switch (message)
   {
   	//----------------------------------------------------------------------//
      // Windows sendet eine WM-CREATE-Message, kurz bevor das Fenster ange-  //
      // zeigt wird. Der Bereich eignet sich nur zur INITIALISIERUNG!         //
   	//----------------------------------------------------------------------//
		case WM_CREATE :
      	  //-----------------------------------------------------------------//
           // Hhe einer Zeile feststellen, damit bei jeder Tastenbotschaft   //
           // um genau diesen Betrag nach oben gescrollt werden kann          //
      	  //-----------------------------------------------------------------//
           hdc = GetDC (hwnd);
           SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT));
           GetTextMetrics (hdc, &tm);
           cxChar = tm.tmAveCharWidth;
           cyChar = tm.tmHeight;
           ReleaseDC (hwnd, hdc);
      	  //-----------------------------------------------------------------//
			  // Oberen Rand des Fensterbereiches fr berschrift vom Scroll-    //
           // bereich abziehen !                                              //
      	  //-----------------------------------------------------------------//
           rect.top = 3 * cyChar / 2;
           return (0);

   	//----------------------------------------------------------------------//
		// Windows schickt eine WM-SIZE-Message, wenn die Gre des Anzeige-    //
      // fensters verndert wird                                              //
   	//----------------------------------------------------------------------//
      case WM_SIZE :
      	  //-----------------------------------------------------------------//
			  // Ausgabe-Rectangle neu setzen                                    //
      	  //-----------------------------------------------------------------//
           rect.right  = LOWORD (lParam);
           rect.bottom = HIWORD (lParam);
        	  //-----------------------------------------------------------------//
			  // Fenster neu zeichnen, UpdateWindow generiert eine neue WM_PAINT //
           // Message                                                         //
      	  //-----------------------------------------------------------------//
           UpdateWindow (hwnd);
           return (0);

   	//----------------------------------------------------------------------//
      // Windows schickt eine WM-Paint-Message, wenn der Programmierer es als //
      // inhaltlich erforderlich ansieht, Bildschirmbereiche neu zu zeichnen, //
      // weil sie verndert wurden                                            //
   	//----------------------------------------------------------------------//
      case WM_PAINT :
      	  //-----------------------------------------------------------------//
			  // den neu zu zeichnenden Bereich festlegen, hier: alles neu       //
      	  //-----------------------------------------------------------------//
           InvalidateRect (hwnd, NULL, TRUE);
           hdc = BeginPaint (hwnd, &ps);
           SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT));
           SetBkMode (hdc, TRANSPARENT);
      	  //-----------------------------------------------------------------//
			  // berschrift neu ausgeben                                        //
      	  //-----------------------------------------------------------------//
           TextOut (hdc, cxChar, cyChar / 2, szTop, (sizeof szTop) - 1);
           TextOut (hdc, cxChar, cyChar / 2, szUnd, (sizeof szUnd) - 1);
           EndPaint (hwnd, &ps);
           return (0);

   	//----------------------------------------------------------------------//
		// WM-KEYDOWN wird gesendet, wenn eine nicht-Systemtaste gedrckt wird  //
   	//----------------------------------------------------------------------//
      case WM_KEYDOWN :
           ShowKey (hwnd, "WM_KEYDOWN", wParam, lParam);
           return (0);

   	//----------------------------------------------------------------------//
		// WM-KEYDOWN wird gesendet, wenn eine nicht-Systemtaste gelst wird    //
   	//----------------------------------------------------------------------//
      case WM_KEYUP :
           ShowKey (hwnd, "WM_KEYUP", wParam, lParam);
           return (0);

   	//----------------------------------------------------------------------//
		// WM-CHAR sendet den modifizierten Zeichencode einer gedrckten Taste  //
   	//----------------------------------------------------------------------//
      case WM_CHAR :
           ShowKey (hwnd, "WM_CHAR", wParam, lParam);
           return (0);

   	//----------------------------------------------------------------------//
		// WM-DEADCHAR wird gesendet, wenn eine weitere Taste gedrckt werden   //
      // mu, um den Zeichencode eindeutig zu spezifizieren (Akzent-Tasten)   //
   	//----------------------------------------------------------------------//
      case WM_DEADCHAR :
           ShowKey (hwnd, "WM_DEADCHAR", wParam, lParam);
           return (0);

   	//----------------------------------------------------------------------//
		// WM-SYSKEYDOWN wird gesendet, wenn eine Steuerungstaste (ALT) ge-     //
      // drckt wird                                                          //
   	//----------------------------------------------------------------------//
		// SYSTEM-Tasten werden von der Default-Windows-Message-Procedure ver-  //
      // arbeitet, daher NICHT RETURN(0) sondern BREAK !!!!!                  //
   	//----------------------------------------------------------------------//
      case WM_SYSKEYDOWN :
           ShowKey (hwnd, "WM_SYSKEYDOWN", wParam, lParam);
           break;

   	//----------------------------------------------------------------------//
		// WM-SYSKEYUP wird gesendet, wenn eine Steuerungstaste (ALT) gelst    //
      // wird                                                                 //
   	//----------------------------------------------------------------------//
		// SYSTEM-Tasten werden von der Default-Windows-Message-Procedure ver-  //
      // arbeitet, daher NICHT RETURN(0) sondern BREAK !!!!!                  //
   	//----------------------------------------------------------------------//
      case WM_SYSKEYUP :
           ShowKey (hwnd, "WM_SYSKEYUP", wParam, lParam);
           break;

   	//----------------------------------------------------------------------//
		// WM-CHAR sendet den Zeichencode einer gedrckten System-Taste         //
   	//----------------------------------------------------------------------//
		// SYSTEM-Tasten werden von der Default-Windows-Message-Procedure ver-  //
      // arbeitet, daher NICHT RETURN(0) sondern BREAK !!!!!                  //
   	//----------------------------------------------------------------------//
      case WM_SYSCHAR :
           ShowKey (hwnd, "WM_SYSCHAR", wParam, lParam);
           break;

   	//----------------------------------------------------------------------//
		// WM-SYSDEADCHAR wird gesendet, wenn eine weitere Taste gedrckt       //
      // werden mu, um den Zeichencode eindeutig zu spezifizieren            //
   	//----------------------------------------------------------------------//
		// SYSTEM-Tasten werden von der Default-Windows-Message-Procedure ver-  //
      // arbeitet, daher NICHT RETURN(0) sondern BREAK !!!!!                  //
   	//----------------------------------------------------------------------//
      case WM_SYSDEADCHAR :
           ShowKey (hwnd, "WM_SYSDEADCHAR", wParam, lParam);
           break;

   	//----------------------------------------------------------------------//
      // WM-DESTROY wird gesendet, wenn das Programm beendet werden soll      //
   	//----------------------------------------------------------------------//
      case WM_DESTROY :
           PostQuitMessage (0);
           return (0);
   }
	return DefWindowProc (hwnd, message, wParam, lParam);
}
