//****************************************************************************//
//   P4.cpp - Maus-Demonstrationsprogramm                                     //
//****************************************************************************//
#include <windows.h>

#define MAXPOINTS 1000

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunction, die die Messages der Client-Area verarbeitet //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
   //-------------------------------------------------------------------------//
	// Hier wieder die vier unverzichtbaren Variablen...                       //
   //-------------------------------------------------------------------------//
	static char szWindowclassname [] = "P4";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWindowclass;

   if (!hPrevInstance)
   {
   	aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_CROSS);
      aWindowclass.hbrBackground = GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = szWindowclassname;

	   RegisterClass (&aWindowclass);
   }
   //-------------------------------------------------------------------------//
	// Fenster erzeugen und anzeigen                                           //
   //-------------------------------------------------------------------------//
   hWindow = CreateWindow (szWindowclassname, "Maus-Demo",
                           WS_OVERLAPPEDWINDOW,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							NULL, NULL, hInstance, NULL);
	ShowWindow   (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   //-------------------------------------------------------------------------//
	// Verarbeiten aller Botschaften an unser Programm                         //
   //-------------------------------------------------------------------------//
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
   	TranslateMessage (&aMessage);
      DispatchMessage  (&aMessage);
   }
   //-------------------------------------------------------------------------//
	// Windowskernel mitteilen, da die WM_QUIT-Message verarbeitet wurde      //
   //-------------------------------------------------------------------------//
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Messagehandler der Client-Area                                             //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   //-------------------------------------------------------------------------//
	// Lokale Variablen                                                        //
   //-------------------------------------------------------------------------//
	// Points ist ein Array, da MAXPOINTS x- und y-Koordinaten speichern kann //
   // nCount enthlt die relevante Anzahl von gesetzten Punkten               //
   // STATIC-VARIABLEN werden beim Verlassen der Funktion im "Gedchtnis" be- //
   // halten und stehen beim nchsten Eintritt in die Fzunktion wieder zur    //
   // Verfgung                                                               //
   //-------------------------------------------------------------------------//
	static POINT points[MAXPOINTS];
   static short nCount;
   HDC          hdc;
   PAINTSTRUCT  ps;
   short        i, j;


   switch (message)
   {
   	//----------------------------------------------------------------------//
		// Windows schickt eine WM-LBUTTONDOWN-Message, wenn die linke Maus-    //
      // taste gedrckt wird                                                  //
   	//----------------------------------------------------------------------//
   	case WM_LBUTTONDOWN :
	        //-----------------------------------------------------------------//
           // Beim drcken der linken Maustaste wieder von vorne beginnen,    //
           // d.h. der Counter wird zurckgesetzt und die gesamte Client-Area //
           // invalidiert                                                     //
	        //-----------------------------------------------------------------//
           nCount = 0;
           InvalidateRect (hwnd, NULL, TRUE);
           return (0);

   	//----------------------------------------------------------------------//
		// Windows schickt eine WM-MOUSEMOVE-Message, wenn die Maus bewegt wird //
   	//----------------------------------------------------------------------//
      case WM_MOUSEMOVE :
	        //-----------------------------------------------------------------//
			  // im wParam ist ein Flag gesetzt, wenn die linke Maustaste ge-    //
           // drckt gehalten wird auerdem ist die maximale Anzahl der       //
           // speicherbaren Punkte zu beachten !                              //
	        //-----------------------------------------------------------------//
           if ((wParam & MK_LBUTTON) && (nCount < MAXPOINTS))
           {
   	        //--------------------------------------------------------------//
				  // wenn beide Bedingungen erfllt sind, dann den Punkt in die   //
              // Punktliste mit aufnehmen. die Koordinaten knnen dem lParam  //
              // entnommen werden                                             //
   	        //--------------------------------------------------------------//
              // unter 32-Bit Windows gibt es das Makro MAKEPOINT nicht mehr  //
              // man mu die Koordinaten daher per Hand zuweisen              //
   	        //--------------------------------------------------------------//
           	  points[nCount].x = LOWORD(lParam);
           	  points[nCount].y = HIWORD(lParam);
              nCount++;

   	        //--------------------------------------------------------------//
				  // Damit man den Punkt auch sehen kann, setzen wir an der ent-  //
              // sprechenden Stelle ein Pixel                                 //
   	        //--------------------------------------------------------------//
              hdc = GetDC (hwnd);
              SetPixel (hdc, LOWORD (lParam), HIWORD (lParam), 0L);
              ReleaseDC (hwnd, hdc);
           }
           return (0);

   	//----------------------------------------------------------------------//
		// Windows schickt eine WM-LBUTTONUP-Message, wenn die linke Maustaste  //
      // losgelassen wird                                                     //
   	//----------------------------------------------------------------------//
      case WM_LBUTTONUP :
	        //-----------------------------------------------------------------//
			  // gesamte Clientarea neu zeichnen	                              //
	        //-----------------------------------------------------------------//
           InvalidateRect (hwnd, NULL, FALSE);
           return (0);

   	//----------------------------------------------------------------------//
		// Zeichnen                                                             //
   	//----------------------------------------------------------------------//
      case WM_PAINT :
			  {
           	  hdc = BeginPaint (hwnd, &ps);
           	  int k = random (5);
              k = 4;
	           //--------------------------------------------------------------//
			     // alle Punkte miteinander verbinden, wenn nCount 0 ist, wird   //
              // diese Schleife nicht ausgefhrt !                            //
	           //--------------------------------------------------------------//

              if (k==0)
              {
           		  for (i = 0; i < nCount - 1; i++)
                 {
                    for (j = i; j < nCount; j++)
                    {
		                 //-----------------------------------------------------//
      		        	  // unter 32-Bit Windows existiert die Funktion MoveTo  //
            		     // nicht mehr, man nehme stattdessen MoveToEx und setze//
		                 // den letzten Parameter auf NULL                      //
      		           //------------------------------------------------------//
	                 	  MoveToEx (hdc, points[i].x, points[i].y, NULL);
   	                 LineTo (hdc, points[j].x, points[j].y);
                    }
                 }
              }
              if (k==1)
              {
                 SetPolyFillMode (hdc, WINDING);

           		  for (i = 0; i < nCount - 1; i++)
                 {
					     COLORREF cref = RGB (random(255),random(255),random (255));
   	              HBRUSH hbr = CreateSolidBrush (cref);
	                 SelectObject (hdc, hbr);

                 	  switch (random (3))
                    {
                 		  case 0: Rectangle (hdc, points[i].x, points[i].y,
                                        points[i].x+random(100),
                                        points[i].y+random(100)); break;
                       case 1: Ellipse (hdc, points[i].x, points[i].y,
                                        points[i].x+random(100),
                                        points[i].y+random(100)); break;
                       case 2: k = random (100);
                       			 Ellipse (hdc, points[i].x, points[i].y,
                                        points[i].x+k,
                                        points[i].y+k); break;
                    }
	                 DeleteObject (hbr);
                 }
              }

              if (k==2)
              {
              	  MoveToEx (hdc, points[0].x, points[0].y, NULL);
           		  for (i = 0; i < nCount - 1; i++)
  	                 LineTo (hdc, points[i].x, points[i].y);
              }

              if (k==3)
              {
                 SetPolyFillMode (hdc, WINDING);
				     COLORREF cref = RGB (random(255),random(255),random (255));
		           HBRUSH hbr = CreateSolidBrush (cref);
      	        SelectObject (hdc, hbr);
					  Polygon (hdc, points, nCount);
            	  DeleteObject (hbr);
              }

              if (k==4)
              {
                 SetPolyFillMode (hdc, WINDING);
           		  for (i = 0; i < nCount; i++)
                 {
					     COLORREF cref = RGB (random(255),random(255),random (255));
  		              HBRUSH hbr = CreateSolidBrush (cref);
      	           SelectObject (hdc, hbr);
						  RoundRect (hdc, points[i].x, points[i].y,
            	                points[i].x+random(100),
               	             points[i].y+random(100),
                             	 random(50), random(50));
                 	  DeleteObject (hbr);
                 }
              }
           }
           EndPaint (hwnd, &ps);
           return (0);

   	//----------------------------------------------------------------------//
		// Programm beenden                                                     //
   	//----------------------------------------------------------------------//
      case WM_DESTROY :
           PostQuitMessage (0);
           return (0);
	}
   return DefWindowProc (hwnd, message, wParam, lParam);
}

