//****************************************************************************//
//   P5.cpp - Maus-Demo 2                                                     //
//****************************************************************************//
#include <windows.h>

#define TEILUNGEN 3

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunction, die die Messages der Client-Area verarbeitet //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
   //-------------------------------------------------------------------------//
	// Hier wieder die vier unverzichtbaren Variablen...                       //
   //-------------------------------------------------------------------------//
	static char szWindowclassname [] = "P5";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWindowclass;

   if (!hPrevInstance)
   {
   	aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = szWindowclassname;

	   RegisterClass (&aWindowclass);
   }
   //-------------------------------------------------------------------------//
	// Fenster erzeugen und anzeigen                                           //
   //-------------------------------------------------------------------------//
   hWindow = CreateWindow (szWindowclassname, "Maus-Demo 2",
                           WS_OVERLAPPEDWINDOW,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							NULL, NULL, hInstance, NULL);
	ShowWindow   (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   //-------------------------------------------------------------------------//
	// Verarbeiten aller Botschaften an unser Programm                         //
   //-------------------------------------------------------------------------//
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
   	TranslateMessage (&aMessage);
      DispatchMessage  (&aMessage);
   }
   //-------------------------------------------------------------------------//
	// Windowskernel mitteilen, da die WM_QUIT-Message verarbeitet wurde      //
   //-------------------------------------------------------------------------//
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Messagehandler der Client-Area                                             //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
	static int   fState[TEILUNGEN][TEILUNGEN];
   static int   cxBlock, cyBlock;
   HDC          hdc;
   PAINTSTRUCT  ps;
   RECT         rect;
   int          x, y;
   static int   what = 1;

   switch (message)
   {
   	//----------------------------------------------------------------------//
		// Gre des Fensters wird verndert                                    //
   	//----------------------------------------------------------------------//
      case WM_SIZE :
      	  //-----------------------------------------------------------------//
           // neue Breite eines Karos feststellen                             //
      	  //-----------------------------------------------------------------//
           cxBlock = LOWORD (lParam) / TEILUNGEN;
      	  //-----------------------------------------------------------------//
           // neue Hhe eines Karos feststellen                               //
      	  //-----------------------------------------------------------------//
           cyBlock = HIWORD (lParam) / TEILUNGEN;
           return (0);

   	//----------------------------------------------------------------------//
		// linke Maustaste wird gedrckt                                        //
   	//----------------------------------------------------------------------//
      case WM_LBUTTONDOWN :
      	  //-----------------------------------------------------------------//
			  // feststellen, in welchem Karo sich der Mauszeiger befindet, in-  //
           // dem die aktuellen Koordinaten durch die xy-Gre des Karos ge-  //
           // teilt werden                                                    //
      	  //-----------------------------------------------------------------//
           x = LOWORD (lParam) / cxBlock;
           y = HIWORD (lParam) / cyBlock;

      	  //-----------------------------------------------------------------//
			  // Wenn es sich beim Ergebnis um einen gltigen Karoindex handelt  //
      	  //-----------------------------------------------------------------//
           if ((x < TEILUNGEN) && (y < TEILUNGEN))
           {
	      	  //--------------------------------------------------------------//
              // Status des Karos ber EXCLUSIVE-OR umschalten !              //
   	   	  //--------------------------------------------------------------//

              if (!fState [x][y])
              {
                 fState [x][y] = what;
     			     if (what == 1) what = 2;
   	           else what = 1;
              }

	      	  //--------------------------------------------------------------//
              // fr die nachfolgende Graphik-Operation das Rectangle des     //
              // Karos feststellen                                            //
   	   	  //--------------------------------------------------------------//
              rect.left   = x * cxBlock;
              rect.top    = y * cyBlock;
              rect.right  = (x + 1) * cxBlock;
              rect.bottom = (y + 1) * cyBlock;
	      	  //--------------------------------------------------------------//
              // genau dieses Rectangle invalidieren, so da es neu gezeich-  //
              // net werden mu                                               //
   	   	  //--------------------------------------------------------------//
              InvalidateRect (hwnd, &rect, FALSE);
           }
      	  //-----------------------------------------------------------------//
			  // Wenn es nicht klappt, dann piepen!                              //
	    	  //-----------------------------------------------------------------//
           else MessageBeep (0xFFFFFFFF);
           return (0);

   	//----------------------------------------------------------------------//
		// neu zeichnen                                                         //
   	//----------------------------------------------------------------------//
      case WM_PAINT :
           hdc = BeginPaint (hwnd, &ps);
      	  //-----------------------------------------------------------------//
			  // Schleife ber alle Karos                                        //
	    	  //-----------------------------------------------------------------//
           for (x = 0; x < TEILUNGEN; x++)
           {
              for (y = 0; y < TEILUNGEN; y++)
              {
      	        //-----------------------------------------------------------//
			        // Rectangle des Karos berechnen                             //
	    	        //-----------------------------------------------------------//
                 Rectangle (hdc, x * cxBlock, y * cyBlock,
                            (x + 1) * cxBlock, (y + 1) * cyBlock);

      	        //-----------------------------------------------------------//
			        // Wenn dieses Karo gesetzt ist, dann Kreuz zeichnen         //
	    	        //-----------------------------------------------------------//
                 if (fState [x][y] == 1)
                 {
                    MoveToEx (hdc,  x    * cxBlock,  y    * cyBlock, NULL);
                    LineTo   (hdc, (x+1) * cxBlock, (y+1) * cyBlock);
                    MoveToEx (hdc,  x    * cxBlock, (y+1) * cyBlock, NULL);
                    LineTo   (hdc, (x+1) * cxBlock,  y    * cyBlock);
                 }
                 if (fState [x][y] == 2)
                 {
                    Ellipse  (hdc, x*cxBlock+1, y*cyBlock+1,
                              (x+1)*cxBlock-1, (y+1)*cyBlock-1);
                 }
              }
           }
           EndPaint (hwnd, &ps);
           return (0);

   	//----------------------------------------------------------------------//
		// Programm beenden                                                     //
   	//----------------------------------------------------------------------//
      case WM_DESTROY :
           PostQuitMessage (0);
           return (0);
	}
   return DefWindowProc (hwnd, message, wParam, lParam);
}

