//****************************************************************************//
//   P5.cpp - Maus-Demo 2                                                     //
//****************************************************************************//
#include <windows.h>

#define TEILUNGEN 5

//----------------------------------------------------------------------------//
// Inline-Funktionen (Makros)                                                 //
//----------------------------------------------------------------------------//
inline int min (int a, int b) { if (a < b) return (a); else return (b); }
inline int max (int a, int b) { if (a > b) return (a); else return (b); }

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunction, die die Messages der Client-Area verarbeitet //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
   //-------------------------------------------------------------------------//
	// Hier wieder die vier unverzichtbaren Variablen...                       //
   //-------------------------------------------------------------------------//
	static char szWindowclassname [] = "P5_1";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWindowclass;

   if (!hPrevInstance)
   {
   	aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = szWindowclassname;

	   RegisterClass (&aWindowclass);
   }
   //-------------------------------------------------------------------------//
	// Fenster erzeugen und anzeigen                                           //
   //-------------------------------------------------------------------------//
   hWindow = CreateWindow (szWindowclassname, "Maus-Demo 2.1",
                           WS_OVERLAPPEDWINDOW,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							NULL, NULL, hInstance, NULL);
	ShowWindow   (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   //-------------------------------------------------------------------------//
	// Verarbeiten aller Botschaften an unser Programm                         //
   //-------------------------------------------------------------------------//
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
   	TranslateMessage (&aMessage);
      DispatchMessage  (&aMessage);
   }
   //-------------------------------------------------------------------------//
	// Windowskernel mitteilen, da die WM_QUIT-Message verarbeitet wurde      //
   //-------------------------------------------------------------------------//
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Messagehandler der Client-Area                                             //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
	static BOOL  fState[TEILUNGEN][TEILUNGEN];
   static int   cxBlock, cyBlock;
   HDC          hdc;
   PAINTSTRUCT  ps;
   RECT         rect;
   int          x, y;
   POINT        point;

   switch (message)
   {
   	//----------------------------------------------------------------------//
		// Gre des Fensters wird verndert                                    //
   	//----------------------------------------------------------------------//
      case WM_SIZE :
               cxBlock = LOWORD (lParam) / TEILUNGEN;
               cyBlock = HIWORD (lParam) / TEILUNGEN;
               return (0);

   	//----------------------------------------------------------------------//
		// Ein Fenster bekommt eine SETFOCUS-Message, wenn es den KEYBOARD-     //
      // Focus (Cursor) erhlt                                                //
   	//----------------------------------------------------------------------//
      case WM_SETFOCUS :
      	  //-----------------------------------------------------------------//
			  // Cursor zeigen	                                                //
      	  //-----------------------------------------------------------------//
           ShowCursor (TRUE);
           return (0);

   	//----------------------------------------------------------------------//
		// Ein Fenster bekommt eine KILLFOCUS-Message, wenn es den KEYBOARD-    //
      // Focus (Cursor) an ein anderes Fenster abgibt                         //
   	//----------------------------------------------------------------------//
      case WM_KILLFOCUS :
      	  //-----------------------------------------------------------------//
			  // Cursor verbergen                                                //
      	  //-----------------------------------------------------------------//
           ShowCursor (FALSE);
           return (0);

   	//----------------------------------------------------------------------//
      // Message: Taste wurde gedrckt                                        //
   	//----------------------------------------------------------------------//
      case WM_KEYDOWN :
      	  //-----------------------------------------------------------------//
			  // Bildschirmkoordinaten des Cursors ermitteln (= in elchem Karo?) //
      	  //-----------------------------------------------------------------//
           GetCursorPos (&point);

      	  //-----------------------------------------------------------------//
			  // aus Bildschirmkoordinaten Fensterkoordinaten machen             //
      	  //-----------------------------------------------------------------//
           ScreenToClient (hwnd, &point);

      	  //-----------------------------------------------------------------//
			  // Entsprechendes Karo ermitteln (karoindex)                       //
      	  //-----------------------------------------------------------------//
           x = max (0, min (TEILUNGEN - 1, point.x / cxBlock));
           y = max (0, min (TEILUNGEN - 1, point.y / cyBlock));

      	  //-----------------------------------------------------------------//
			  // Auswerten der gedrckten Taste                                  //
			  // Return/Eingabe und Leertaste simulieren einen Click der linken  //
           // Maustaste, indem sie einfach die entsprechende Message senden...//
        	  //-----------------------------------------------------------------//
           switch (wParam)
           {
              case VK_UP     : y--;         		  break;
              case VK_DOWN   : y++;         		  break;
              case VK_LEFT   : x--;         		  break;
              case VK_RIGHT  : x++;         		  break;
              case VK_PRIOR  : y = 0;             break;
              case VK_NEXT   : y = TEILUNGEN - 1; break;
              case VK_HOME   : x = 0; y = 0;      break;
              case VK_END    : x = TEILUNGEN - 1;
              						 y = TEILUNGEN - 1; break;
              case VK_ESCAPE : SendMessage (hwnd, WM_DESTROY, 0, 0L);
                               break;
              case VK_RETURN :
              case VK_SPACE  : SendMessage (hwnd, WM_LBUTTONDOWN, MK_LBUTTON,
                                            MAKELONG (x*cxBlock, y*cyBlock));
                               break;
           }

      	  //-----------------------------------------------------------------//
			  // Fr die Cursorpositionierung ist die Mittelposition des Karos   //
           // zu berechnen                                                    //
      	  //-----------------------------------------------------------------//
           x = (x + TEILUNGEN) % TEILUNGEN;
           y = (y + TEILUNGEN) % TEILUNGEN;
           point.x = x * cxBlock + cxBlock / 2;
           point.y = y * cyBlock + cyBlock / 2;

      	  //-----------------------------------------------------------------//
			  // Fensterkoordinaten wieder in Bildschirmkoordinaten umsetzen und //
           // Cursorposition ndern                                           //
      	  //-----------------------------------------------------------------//
           ClientToScreen (hwnd, &point);
           SetCursorPos (point.x, point.y);
           return (0);

   	//----------------------------------------------------------------------//
		// linke Maustaste wird gedrckt                                        //
   	//----------------------------------------------------------------------//
      case WM_LBUTTONDOWN :
      	  //-----------------------------------------------------------------//
			  // feststellen, in welchem Karo sich der Mauszeiger befindet, in-  //
           // dem die aktuellen Koordinaten durch die xy-Gre des Karos ge-  //
           // teilt werden                                                    //
      	  //-----------------------------------------------------------------//
           x = LOWORD (lParam) / cxBlock;
           y = HIWORD (lParam) / cyBlock;

      	  //-----------------------------------------------------------------//
			  // Wenn es sich beim Ergebnis um einen gltigen Karoindex handelt  //
      	  //-----------------------------------------------------------------//
           if ((x < TEILUNGEN) && (y < TEILUNGEN))
           {
	      	  //--------------------------------------------------------------//
              // Status des Karos ber EXCLUSIVE-OR umschalten !              //
   	   	  //--------------------------------------------------------------//
              fState [x][y] ^= 1;

	      	  //--------------------------------------------------------------//
              // fr die nachfolgende Graphik-Operation das Rectangle des     //
              // Karos feststellen                                            //
   	   	  //--------------------------------------------------------------//
              rect.left   = x * cxBlock;
              rect.top    = y * cyBlock;
              rect.right  = (x + 1) * cxBlock;
              rect.bottom = (y + 1) * cyBlock;
	      	  //--------------------------------------------------------------//
              // genau dieses Rectangle invalidieren, so da es neu gezeich-  //
              // net werden mu                                               //
   	   	  //--------------------------------------------------------------//
              InvalidateRect (hwnd, &rect, FALSE);
           }
      	  //-----------------------------------------------------------------//
			  // Wenn es nicht klappt, dann piepen!                              //
	    	  //-----------------------------------------------------------------//
           else MessageBeep (0xFFFFFFFF);
           return (0);

   	//----------------------------------------------------------------------//
		// neu zeichnen                                                         //
   	//----------------------------------------------------------------------//
      case WM_PAINT :
           hdc = BeginPaint (hwnd, &ps);
      	  //-----------------------------------------------------------------//
			  // Schleife ber alle Karos                                        //
	    	  //-----------------------------------------------------------------//
           for (x = 0; x < TEILUNGEN; x++)
           {
              for (y = 0; y < TEILUNGEN; y++)
              {
      	        //-----------------------------------------------------------//
			        // Rectangle des Karos berechnen                             //
	    	        //-----------------------------------------------------------//
                 Rectangle (hdc, x * cxBlock, y * cyBlock,
                            (x + 1) * cxBlock, (y + 1) * cyBlock);

      	        //-----------------------------------------------------------//
			        // Wenn dieses Karo gesetzt ist, dann Kreuz zeichnen         //
	    	        //-----------------------------------------------------------//
                 if (fState [x][y])
                 {
                    MoveToEx (hdc,  x    * cxBlock,  y    * cyBlock, NULL);
                    LineTo   (hdc, (x+1) * cxBlock, (y+1) * cyBlock);
                    MoveToEx (hdc,  x    * cxBlock, (y+1) * cyBlock, NULL);
                    LineTo   (hdc, (x+1) * cxBlock,  y    * cyBlock);
                 }
              }
           }
           EndPaint (hwnd, &ps);
           return (0);

   	//----------------------------------------------------------------------//
		// Programm beenden                                                     //
   	//----------------------------------------------------------------------//
      case WM_DESTROY :
           PostQuitMessage (0);
           return (0);
	}
   return DefWindowProc (hwnd, message, wParam, lParam);
}

