//****************************************************************************//
//   P5.cpp - Maus-Demo 2                                                     //
//****************************************************************************//
#include <windows.h>

#define TEILUNGEN 35

//----------------------------------------------------------------------------//
// Inline-Funktionen (Makros)                                                 //
//----------------------------------------------------------------------------//
inline int min (int a, int b) { if (a < b) return (a); else return (b); }
inline int max (int a, int b) { if (a > b) return (a); else return (b); }

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunktionen Client-Area und Child-Windows               //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc      (HWND, UINT, UINT, LONG);
long FAR PASCAL _export ChildWndProc (HWND, UINT, UINT, LONG);

char szChildClassName[] = "P5_2_Child";

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
   //-------------------------------------------------------------------------//
	// Hier wieder die vier unverzichtbaren Variablen...                       //
   //-------------------------------------------------------------------------//
	static char szWindowclassname [] = "P5_2";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWindowclass;

   if (!hPrevInstance)
   {
      //----------------------------------------------------------------------//
      // Registrierung der Client-Area                                        //
      //----------------------------------------------------------------------//
   	aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = szWindowclassname;

	   RegisterClass (&aWindowclass);

      //----------------------------------------------------------------------//
      // Registrierung der Child-Windowsklasse                                //
      //----------------------------------------------------------------------//
      aWindowclass.lpfnWndProc   = ChildWndProc;
      aWindowclass.cbWndExtra    = sizeof (WORD);
      aWindowclass.hIcon         = NULL;
      aWindowclass.lpszClassName = szChildClassName;

      RegisterClass (&aWindowclass);
   }

   //-------------------------------------------------------------------------//
	// Fenster erzeugen und anzeigen                                           //
   //-------------------------------------------------------------------------//
   hWindow = CreateWindow (szWindowclassname, "Maus-Demo 2.2",
                           WS_OVERLAPPEDWINDOW,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							CW_USEDEFAULT, CW_USEDEFAULT,
      							NULL, NULL, hInstance, NULL);
	ShowWindow   (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   //-------------------------------------------------------------------------//
	// Verarbeiten aller Botschaften an unser Programm                         //
   //-------------------------------------------------------------------------//
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
   	TranslateMessage (&aMessage);
      DispatchMessage  (&aMessage);
   }
   //-------------------------------------------------------------------------//
	// Windowskernel mitteilen, da die WM_QUIT-Message verarbeitet wurde      //
   //-------------------------------------------------------------------------//
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Messagehandler der Client-Area                                             //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   static HWND hwndChild [TEILUNGEN] [TEILUNGEN];
   int         cxBlock, cyBlock;
   int         x, y;

   switch (message)
   {
   	//----------------------------------------------------------------------//
		// Als erste Manahme in der Initialisierung erzeugen wird TEILUNGEN *  //
      // TEILUNGEN unabhngige Fensterchen, wichtig ist, da die Daten des    //
      // bergeordneten Fensters mit eingetragen werden (hwnd)                //
   	//----------------------------------------------------------------------//
		case WM_CREATE :
           for (x = 0; x < TEILUNGEN; x++)
           {
              for (y = 0; y < TEILUNGEN; y++)
              {
                 //-----------------------------------------------------------//
					  // Ein Child-Window ist ein (fast ganz) normales Fenster     //
                 // lediglich das MENU-HANDLE wird anders verwendet, nmlich  //
                 // als Speicherplatz fr eine ID-Nummer des Fensters. Die ID //
                 // wird vom Programmierer vergeben und hier aus dem x und y- //
                 // Index abgeleitet. Das Handle der Programm-Instance wird   //
                 // hier direkt aus der Fensterbeschreibung der Client-Area   //
                 // gewonnen, indem auf die Windowsinternen Fensterdaten zu-  //
                 // gegriffen wird                                            //
                 //-----------------------------------------------------------//
                 hwndChild [x][y] = CreateWindow (szChildClassName, NULL,
                                    WS_CHILDWINDOW | WS_VISIBLE,
                                    0, 0, 0, 0, hwnd, (HMENU)((y << 8) | x),
                                    (HANDLE)GetWindowLong (hwnd, GWL_HINSTANCE),
                                    NULL);
              }
           }
           return (0);

   	//----------------------------------------------------------------------//
		// Gre des Fensters wird verndert. Diese Message kommt zu Beginn     //
		// des Programms einmal ganz automatisch, da natrlich das Erzeugen des //
      // des Fensters eine Grenvernderung ist                              //
   	//----------------------------------------------------------------------//
      case WM_SIZE :
   	     //-----------------------------------------------------------------//
		     // Gre jedes Childfensters ermitteln                             //
   	     //-----------------------------------------------------------------//
           cxBlock = LOWORD (lParam) / TEILUNGEN;
           cyBlock = HIWORD (lParam) / TEILUNGEN;

   	     //-----------------------------------------------------------------//
		     // Jedes Childwindow an den richtigen Platz rcken                 //
   	     //-----------------------------------------------------------------//
           for (x = 0; x < TEILUNGEN; x++)
           {
              for (y = 0; y < TEILUNGEN; y++)
              {
                 MoveWindow (hwndChild [x][y], x * cxBlock, y * cyBlock,
                            cxBlock, cyBlock, TRUE);
              }
           }
           return (0);

   	//----------------------------------------------------------------------//
		// Warnsignal, wenn die linke Maustaste ber der Client-Area abgefangen //
      // wird                                                                 //
   	//----------------------------------------------------------------------//
      case WM_LBUTTONDOWN :
           MessageBeep (0);
           return (0);

   	//----------------------------------------------------------------------//
		// Programm beenden                                                     //
   	//----------------------------------------------------------------------//
      case WM_DESTROY :
           PostQuitMessage (0);
           return (0);
	}
   return (DefWindowProc (hwnd, message, wParam, lParam));
}

//----------------------------------------------------------------------------//
// Messagehandler der Child-Fenster                                           //
//----------------------------------------------------------------------------//
long FAR PASCAL _export ChildWndProc (HWND hwnd, UINT message, UINT wParam,
                                      LONG lParam)
{
	HDC         hdc;
   PAINTSTRUCT ps;
   RECT        rect;
   static int  what;

   switch (message)
   {
   	//----------------------------------------------------------------------//
		// Jedes Childfenster bekommt fr sich jeweils eine WM_CREATE-Message   //
      // Daher knnen wir diese benutzen, um die Werte (an/aus) zu initiali-  //
      // sieren                                                               //
   	//----------------------------------------------------------------------//
   	case WM_CREATE :
           SetWindowWord (hwnd, 0, 0);
           what = 1;
           return (0);

   	//----------------------------------------------------------------------//
		// Wenn ber einem Childwindow die linke Maustaste bettigt wird, dann  //
      // erhlt dieses Fenster-Handle (hwnd) eine WM_LBUTTONDOWN Message      //
   	//----------------------------------------------------------------------//
      case WM_LBUTTONDOWN :
   	     //-----------------------------------------------------------------//
		     // Zustand (an/aus) umschalten                                     //
   	     //-----------------------------------------------------------------//
           if (GetWindowWord (hwnd, 0) == 0)
           {
           	  if (what == 1)
              {
		     		  SetWindowWord (hwnd, 0, (WORD)1);
                 what = 2;
              }
              else
              {
                 SetWindowWord (hwnd, 0, (WORD)2);
                 what = 1;
              }

           }

   	     //-----------------------------------------------------------------//
		     // Jetzt invalidieren wir genau dieses Fenster, so da auch nur    //
			  // das Childfenster neu gezeichnet werden mu (erheblich schneller)//
   	     //-----------------------------------------------------------------//
           InvalidateRect (hwnd, NULL, FALSE);
           return (0);

   	//----------------------------------------------------------------------//
		// Zeichnen eines Childfensters                                         //
   	//----------------------------------------------------------------------//
      case WM_PAINT :
           hdc = BeginPaint (hwnd, &ps);
   	     //-----------------------------------------------------------------//
			  // hwnd ist jetzt das Handle des CHILD-Fensters, eine Umrechnung   //
           // ber Indices ist also nicht mehr ntig !!                       //
   	     //-----------------------------------------------------------------//
           GetClientRect (hwnd, &rect);

   	     //-----------------------------------------------------------------//
			  // Rechteck um das Childwindow malen                               //
   	     //-----------------------------------------------------------------//
           Rectangle (hdc, 0, 0, rect.right, rect.bottom);

   	     //-----------------------------------------------------------------//
			  // ggf. Karo mit Kreuz versehen                                    //
   	     //-----------------------------------------------------------------//
           if (GetWindowWord (hwnd, 0))
           {
           	  if (GetWindowWord (hwnd, 0) == 1)
              {
           	     MoveToEx (hdc, 0,          0, NULL);
                 LineTo   (hdc, rect.right, rect.bottom);
                 MoveToEx (hdc, 0,        rect.bottom, NULL);
                 LineTo   (hdc, rect.right, 0);
              }
              if (GetWindowWord (hwnd, 0) == 2)
              {
              	  Ellipse (hdc, 1, 1, rect.right-1, rect.bottom-1);
              }
           }
           EndPaint (hwnd, &ps);
           return (0);
	}
   return (DefWindowProc (hwnd, message, wParam, lParam));
}
