//---------------------------------------
// P20FILE
//--------------------------------------*/

#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>

// Struktur-Variable fr den Common-System-Dialog "Datei ffnen"
static OPENFILENAME ofn ;

// Initialisierung Struktur-Variable fr den Common-System-Dialog "Datei ffnen"
void PopFileInitialize (HWND hwnd)
{
   static char *szFilter[] = { "Textdateien (*.TXT)",  "*.txt",
                               "ASCII-Dateien (*.ASC)", "*.asc",
                               "Alle Dateien (*.*)",     "*.*",
                               "" } ;

   ofn.lStructSize       = sizeof (OPENFILENAME) ;
   ofn.hwndOwner         = hwnd ;
   ofn.hInstance         = NULL ;
   ofn.lpstrFilter       = szFilter [0] ;
   ofn.lpstrCustomFilter = NULL ;
   ofn.nMaxCustFilter    = 0 ;
   ofn.nFilterIndex      = 0 ;
   ofn.lpstrFile         = NULL ;          // Bei ffnen bzw. Schlieen gesetzt
   ofn.nMaxFile          = _MAX_PATH ;
   ofn.lpstrFileTitle    = NULL ;          // Bei ffnen bzw. Schlieen gesetzt
   ofn.nMaxFileTitle     = _MAX_FNAME + _MAX_EXT ;
   ofn.lpstrInitialDir   = NULL ;
   ofn.lpstrTitle        = NULL ;
   ofn.Flags             = 0 ;             // Bei ffnen bzw. Schlieen gesetzt
   ofn.nFileOffset       = 0 ;
   ofn.nFileExtension    = 0 ;
   ofn.lpstrDefExt       = "txt" ;
   ofn.lCustData         = 0L ;
   ofn.lpfnHook          = NULL ;
   ofn.lpTemplateName    = NULL ;
}

// Aufruf Common-System-Dialog "Datei ffnen"
BOOL PopFileOpenDlg (HWND hwnd, LPSTR lpstrFileName, LPSTR lpstrTitleName)
{
   ofn.hwndOwner         = hwnd ;
   ofn.lpstrFile         = lpstrFileName ;
   ofn.lpstrFileTitle    = lpstrTitleName ;
   ofn.Flags             = OFN_CREATEPROMPT ;

   return GetOpenFileName (&ofn) ;
}

// Aufruf Common-System-Dialog "Datei sichern"
BOOL PopFileSaveDlg (HWND hwnd, LPSTR lpstrFileName, LPSTR lpstrTitleName)
{
   ofn.hwndOwner         = hwnd ;
   ofn.lpstrFile         = lpstrFileName ;
   ofn.lpstrFileTitle    = lpstrTitleName ;
   ofn.Flags             = OFN_OVERWRITEPROMPT ;

   return GetSaveFileName (&ofn) ;
}

// Ermittlung der Dateilnge
static long PopFileLength (int hFile)
{
   long lCurrentPos = _llseek (hFile, 0L, FILE_CURRENT) ;
   long lFileLength = _llseek (hFile, 0L, FILE_END) ;

   _llseek (hFile, lCurrentPos, FILE_BEGIN) ;

   return (lFileLength);
}

// Lesen der Datei
BOOL PopFileRead (HWND hwndEdit, LPSTR lpstrFileName)
{
   long   lLength ;
   HANDLE hBuffer ;
   int    hFile ;
   LPSTR  lpstrBuffer ;

   if (-1 == (hFile = _lopen (lpstrFileName, OF_READ | OF_SHARE_DENY_WRITE)))
      return FALSE ;

   if ((lLength = PopFileLength (hFile)) >= 32000)
   {
      _lclose (hFile) ;
      return FALSE ;
   }

   if (NULL == (hBuffer = GlobalAlloc (GHND, lLength + 1)))
   {
      _lclose (hFile) ;
      return FALSE ;
   }

   lpstrBuffer = (LPSTR)GlobalLock (hBuffer) ;
   _lread (hFile, lpstrBuffer, (WORD) lLength) ;
   _lclose (hFile) ;
   lpstrBuffer [(WORD) lLength] = '\0' ;

   SetWindowText (hwndEdit, lpstrBuffer) ;
   GlobalUnlock (hBuffer) ;
   GlobalFree (hBuffer) ;

   return TRUE ;
}

// Datei Schreiben
BOOL PopFileWrite (HWND hwndEdit, LPSTR lpstrFileName)
{
   HANDLE hBuffer ;
   int    hFile ;
   LPSTR  lpstrBuffer ;
   UINT   wLength ;

   if (-1 == (hFile = _lopen (lpstrFileName, OF_WRITE | OF_SHARE_EXCLUSIVE)))
      if (-1 == (hFile = _lcreat (lpstrFileName, 0)))
         return FALSE ;

   wLength = GetWindowTextLength (hwndEdit) ;
   hBuffer = (HANDLE) SendMessage (hwndEdit, EM_GETHANDLE, 0, 0L) ;
   lpstrBuffer = (LPSTR) LocalLock (hBuffer) ;

   if (wLength != _lwrite (hFile, lpstrBuffer, wLength))
   {
      _lclose (hFile) ;
      return FALSE ;
   }

   _lclose (hFile) ;
   LocalUnlock (hBuffer) ;

   return TRUE ;
}
