/*---------------------------------------------------------
POPFIND.C -- Funktionen "Suchen" und "Ersetzen" fr POPPAD
-----------------------------------------------------------*/

#include <windows.h>
#include <commdlg.h>
#include <string.h>
#define MAX_STRING_LEN   256

static char szFindText [MAX_STRING_LEN] ;
static char szReplText [MAX_STRING_LEN] ;

// Common System Dialog fr Suchen
HWND PopFindFindDlg (HWND hwnd)
{
	static FINDREPLACE fr ;      // fr moduslosen Dialog, *mu* statisch sein!

   fr.lStructSize      = sizeof (FINDREPLACE) ;
   fr.hwndOwner        = hwnd ;
   fr.hInstance        = NULL ;
   fr.Flags            = FR_HIDEUPDOWN | FR_HIDEMATCHCASE | FR_HIDEWHOLEWORD ;
   fr.lpstrFindWhat    = szFindText ;
   fr.lpstrReplaceWith = NULL ;
   fr.wFindWhatLen     = sizeof (szFindText) ;
   fr.wReplaceWithLen  = 0 ;
   fr.lCustData        = 0 ;
   fr.lpfnHook         = NULL ;
   fr.lpTemplateName   = NULL ;

   return FindText (&fr) ;
}

// Common System Dialog fr Suchen und Ersetzen
HWND PopFindReplaceDlg (HWND hwnd)
{
	static FINDREPLACE fr ;      // fr moduslosen Dialog, *mu* statisch sein!

   fr.lStructSize      = sizeof (FINDREPLACE) ;
   fr.hwndOwner        = hwnd ;
   fr.hInstance        = NULL ;
   fr.Flags            = FR_HIDEUPDOWN | FR_HIDEMATCHCASE | FR_HIDEWHOLEWORD ;
   fr.lpstrFindWhat    = szFindText ;
   fr.lpstrReplaceWith = szReplText ;
   fr.wFindWhatLen     = sizeof (szFindText) ;
   fr.wReplaceWithLen  = sizeof (szReplText) ;
   fr.lCustData        = 0 ;
   fr.lpfnHook         = NULL ;
   fr.lpTemplateName   = NULL ;

   return ReplaceText (&fr) ;
}

// Textsuche
BOOL PopFindFindText (HWND hwndEdit, int *piSearchOffset, LPFINDREPLACE lpfr)
{
   int         iPos ;
   LOCALHANDLE hLocal ;
   LPSTR       lpstrDoc, lpstrPos ;

   // Zeiger auf das Dokument ermitteln (Speicheradresse)
   hLocal   = (HWND) SendMessage (hwndEdit, EM_GETHANDLE, 0, 0L) ;
   lpstrDoc = (LPSTR) LocalLock (hLocal) ;

   // Suche nach dem Text innerhalb des Dokuments
   lpstrPos = _fstrstr (lpstrDoc + *piSearchOffset, lpfr->lpstrFindWhat) ;
   LocalUnlock (hLocal) ;

   // Abbruch mit Fehlercode, falls erfolglos
   if (lpstrPos == NULL)
   	return FALSE ;

   // Sonst Startadresse bestimmen und neu setzen fr nchste Suche
   iPos = lpstrPos - lpstrDoc ;
   *piSearchOffset = iPos + _fstrlen (lpfr->lpstrFindWhat) ;

   // Auswhlen des gefundenen Texts
   SendMessage (hwndEdit, EM_SETSEL, 0, MAKELONG (iPos, *piSearchOffset)) ;
   return TRUE ;
}

// Textsuche, nchstes Textvorkommen
BOOL PopFindNextText (HWND hwndEdit, int *piSearchOffset)
{
   FINDREPLACE fr ;

   fr.lpstrFindWhat = szFindText ;

   return PopFindFindText (hwndEdit, piSearchOffset, &fr) ;
}

// Textersetzung
BOOL PopFindReplaceText (HWND hwndEdit, int *piSearchOffset, LPFINDREPLACE lpfr)
{
	// Text lokalisieren
   if (!PopFindFindText (hwndEdit, piSearchOffset, lpfr))
      return FALSE ;

   // ... und ersetzen
   SendMessage (hwndEdit, EM_REPLACESEL, 0, (long) lpfr->lpstrReplaceWith) ;
   return TRUE ;
}

BOOL PopFindValidFind (void)
{
   return *szFindText != '\0' ;
}
