/*------------------------------------------
   P20FONT.CPP
  ------------------------------------------*/

#include <windows.h>
#include <commdlg.h>

static LOGFONT logfont ;
static HFONT   hFont ;

// Common-System-Dialog fr Font-Auswahl
BOOL PopFontChooseFont (HWND hwnd)
{
   CHOOSEFONT cf ;

   cf.lStructSize      = sizeof (CHOOSEFONT) ;
   cf.hwndOwner        = hwnd ;
   cf.hDC              = NULL ;
   cf.lpLogFont        = &logfont ;
   cf.iPointSize       = 0 ;
   cf.Flags            = CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS
                                                  | CF_EFFECTS ;
   cf.rgbColors        = 0L ;
   cf.lCustData        = 0L ;
   cf.lpfnHook         = NULL ;
   cf.lpTemplateName   = NULL ;
   cf.hInstance        = NULL ;
   cf.lpszStyle        = NULL ;
   cf.nFontType        = 0 ;               // von ChooseFont geliefert
   cf.nSizeMin         = 0 ;
   cf.nSizeMax         = 0 ;

   return ChooseFont (&cf) ;
}

// Initialisierung Common-System-Dialog fr Font-Auswahl
void PopFontInitialize (HWND hwndEdit)
{
   GetObject (GetStockObject (SYSTEM_FONT), sizeof (LOGFONT),
                                              (LPSTR) &logfont) ;
   hFont = CreateFontIndirect (&logfont) ;
   SendMessage (hwndEdit, WM_SETFONT, (WPARAM)hFont, 0L) ;
}

// Fontauswahl setzen
void PopFontSetFont (HWND hwndEdit)
{
   HFONT hFontNew ;

   hFontNew = CreateFontIndirect (&logfont) ;
   SendMessage (hwndEdit, WM_SETFONT, (WPARAM)hFontNew, 0L) ;
   DeleteObject (hFont) ;
   hFont = hFontNew ;
}

// Font wieder entfernen
void PopFontDeinitialize (void)
{
   DeleteObject (hFont) ;
}
