//****************************************************************************//
//   P6d.cpp - Digitaluhr                                                     //
//****************************************************************************//
#include <windows.h>
#include <time.h>

#define ID_TIMER    1

//----------------------------------------------------------------------------//
// Makros                                                                     //
//----------------------------------------------------------------------------//
#define YEAR  (datetime->tm_year % 100)
#define MONTH (datetime->tm_mon  + 1)
#define MDAY  (datetime->tm_mday)
#define WDAY  (datetime->tm_wday)
#define HOUR  (datetime->tm_hour)
#define MIN   (datetime->tm_min)
#define SEC   (datetime->tm_sec)

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunction, die die Messages der Client-Area verarbeitet //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// Funktionsprototypen                                                        //
//----------------------------------------------------------------------------//
void SizeTheWindow    (int&, int&, int&, int&);
void SetInternational (void);
void WndPaint (HWND hwnd, HDC hdc);

//----------------------------------------------------------------------------//
// globale Variablen                                                          //
//----------------------------------------------------------------------------//
char  sDate [2], sTime [2], sAMPM [2][5];
int   iDate, iTime;

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
	static char szWindowclassname[] = "P6d";
   HWND        hWindow;
   MSG         aMessage;
   int         xStart, yStart, xClient, yClient;
   WNDCLASS    aWndclass;

   if (!hPrevInstance)
   {
   	aWndclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWndclass.lpfnWndProc   = WndProc;
      aWndclass.cbClsExtra    = 0;
      aWndclass.cbWndExtra    = 0;
      aWndclass.hInstance     = hInstance;
      aWndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
	   aWndclass.lpszMenuName  = NULL;
      aWndclass.lpszClassName = szWindowclassname;

      RegisterClass (&aWndclass);
	}

   //-------------------------------------------------------------------------//
   // Fenster auf die bentigte Gre bringen                                 //
   //-------------------------------------------------------------------------//
   SizeTheWindow (xStart, yStart, xClient, yClient);

   hWindow = CreateWindow (szWindowclassname, "Timer-Demo 2",
                           WS_POPUP | WS_DLGFRAME | WS_SYSMENU,
                           xStart-40,  yStart-40,
                           xClient, yClient,
                           NULL, NULL, hInstance, NULL);

   //-------------------------------------------------------------------------//
   // mit der Funktion SetTimer kann man bei Windows den Wunsch anmelden, da //
   // Windows in bestimmten Zeitintervallen eine genau definierte Message     //
   // schicken soll                                                           //
   //-------------------------------------------------------------------------//
   if (!SetTimer (hWindow, ID_TIMER, 1000, NULL))
   {
      //----------------------------------------------------------------------//
		// MessageBox ist eine sehr einfache und ntzliche Funktion, um dem An- //
      // wender Hinweise bzw. Fehlermeldungen zukommen zu lassen....          //
      //----------------------------------------------------------------------//
      MessageBox (hWindow, "Zuviele Timer!", szWindowclassname,
                             MB_ICONEXCLAMATION | MB_OK);
      return FALSE;
   }

	ShowWindow   (hWindow, SW_SHOWNOACTIVATE);
   UpdateWindow (hWindow);

   while (GetMessage (&aMessage, NULL, 0, 0))
   {
	   TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return (aMessage.wParam);
}


//----------------------------------------------------------------------------//
// Funktion zum ndern der Fenstergre                                       //
//----------------------------------------------------------------------------//
void SizeTheWindow (int& pxStart,  int& pyStart, int& pxClient, int& pyClient)
{
   HDC        hdc;
   TEXTMETRIC tm;

   //-------------------------------------------------------------------------//
   // mit CREATEIC knnen wir den InformationContext abrufen, d.h. z.B. Infos //
   // ber den Bildschirmtreiber etc. Hier erfolgt der Aufruf um die ent-     //
   // sprechenden Systemvariablen zu aktualisieren                            //
   //-------------------------------------------------------------------------//
   hdc = CreateIC ("DISPLAY", NULL, NULL, NULL);
   GetTextMetrics (hdc, &tm);
   DeleteDC (hdc);

   pxClient = 2 * GetSystemMetrics (SM_CXDLGFRAME) + 16 * tm.tmAveCharWidth;
   pxStart  =     GetSystemMetrics (SM_CXSCREEN)   - pxClient;
   pyClient = 2 * GetSystemMetrics (SM_CYDLGFRAME) + 2 * tm.tmHeight;
   pyStart  =     GetSystemMetrics (SM_CYSCREEN)   - pyClient;
}

//----------------------------------------------------------------------------//
// Funktion zum ndern der Darstellung                                        //
//----------------------------------------------------------------------------//
void SetInternational (void)
{
   static char cName [] = "intl";

   //-------------------------------------------------------------------------//
   // GetProfileInt liest einen Integerwert aus der WIN.INI, hier die beiden  //
   // Eintrge "iDate=" und "iTime=" aus der Section "intl". Werden die Ein-  //
   // trge nicht gefunden, so wird 0 (3. Parameter) als Voreinstellung zu-   //
   // rckgegeben.-                                                           //
   // Fr andere .INI-Dateien verwendet man die Function GetPrivateProfileInt //
   // die als 4. Parameter den Filenamen der INI-Datei enthlt                //
   //-------------------------------------------------------------------------//
   iDate = GetProfileInt (cName, "iDate", 0);
   iTime = GetProfileInt (cName, "iTime", 0);

   //-------------------------------------------------------------------------//
   // GetProfileInt liest einen String aus der WIN.INI, hier u.a. die beiden  //
   // Eintrge "sDate=" und "sTime=" aus der Section "intl". Werden die Ein-  //
   // trge nicht gefunden, so wird der angegebene String (3. Parameter) auf  //
   // die angefhrte Stringvariable kopiert (4. Parameter) der 5. Parameter   //
   // enthlt die Gre (Buffersize) der aufnehmenden Variablen               //
   // Fr andere INI-Dateien verwendet man GetPrivateProfileString, welche    //
   // als 6. Parameter den Filenamen der INI-Datei enthlt                    //
   //-------------------------------------------------------------------------//
   GetProfileString (cName, "sDate",  "/", sDate,     2);
   GetProfileString (cName, "sTime",  ":", sTime,     2);
   GetProfileString (cName, "s1159", "AM", sAMPM [0], 5);
   GetProfileString (cName, "s2359", "PM", sAMPM [1], 5);
}

//----------------------------------------------------------------------------//
// Ausgelagerte Funktion fr die WM_PAINT-Message                             //
//----------------------------------------------------------------------------//
void WndPaint (HWND hwnd, HDC hdc)
{
   static char szWday[] = "So\0Mo\0Di\0Mi\0Do\0Fr\0Sa";
   char        cBuffer[40];
   long        lTime;
   RECT        rect;
   int         nLength;
   struct tm   *datetime;

   //-------------------------------------------------------------------------//
   // Uhrzeit holen                                                           //
   //-------------------------------------------------------------------------//
   time (&lTime);
   datetime = localtime (&lTime);

   //-------------------------------------------------------------------------//
   // Datum   gem der in der WIN.INI eingestellten Form aufbereiten         //
   //-------------------------------------------------------------------------//
   nLength = wsprintf (cBuffer, "  %s  %d%s%02d%s%02d  \r\n",
             (LPSTR) szWday + 3 * WDAY,
             iDate == 1 ? MDAY  : iDate == 2 ? YEAR  : MONTH, (LPSTR) sDate,
             iDate == 1 ? MONTH : iDate == 2 ? MONTH : MDAY,  (LPSTR) sDate,
             iDate == 1 ? YEAR  : iDate == 2 ? MDAY  : YEAR);

   //-------------------------------------------------------------------------//
   // Uhrzeit gem der in der WIN.INI eingestellten Form (24/12)aufbereiten  //
   //-------------------------------------------------------------------------//
   if (iTime == 1)
   {
      wsprintf (cBuffer + nLength, "  %02d%s%02d%s%02d  ",
                HOUR, (LPSTR) sTime, MIN, (LPSTR) sTime, SEC);
   }
   else
   {
      wsprintf (cBuffer + nLength, "  %d%s%02d%s%02d %s  ",
                (HOUR % 12) ? (HOUR % 12) : 12,
                (LPSTR) sTime, MIN, (LPSTR) sTime, SEC,
                (LPSTR) sAMPM [HOUR / 12]);
   }

   //-------------------------------------------------------------------------//
   // und ausgeben                                                            //
   //-------------------------------------------------------------------------//
   GetClientRect (hwnd, &rect);
   DrawText (hdc, cBuffer, -1, &rect, DT_CENTER | DT_NOCLIP);
}

//----------------------------------------------------------------------------//
// Handler-Function der Client-Area                                           //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   HDC         hdc;
   PAINTSTRUCT ps;

   switch (message)
   {
      //----------------------------------------------------------------------//
      // Initialisierung beim ffnen des Fensters - ausgelagert               //
      //----------------------------------------------------------------------//
      case WM_CREATE :
           SetInternational ();
           return (0);

      //----------------------------------------------------------------------//
      // Timer-Message - fhrt zur Invalidierung, um Zeit neu auszugeben      //
      //----------------------------------------------------------------------//
      case WM_TIMER :
           InvalidateRect (hwnd, NULL, FALSE);
           return (0);

      //----------------------------------------------------------------------//
      // Neuzeichnen bei Invalisierung des Fensters - ausgelagert             //
      //----------------------------------------------------------------------//
      case WM_PAINT :
           hdc = BeginPaint (hwnd, &ps);
           WndPaint (hwnd, hdc);
           EndPaint (hwnd, &ps);
           return (0);

      //----------------------------------------------------------------------//
      // Wir wollen mitbekommen, wenn die WIN.INI gendert wird, knnte uns   //
      // ja hinsichtlich des Zeitformats betreffen. Windows teilt dies allen  //
      // laufenden Programmen durch eine WM_WININICHANGE-Message mit          //
      //----------------------------------------------------------------------//
      case WM_WININICHANGE :
           SetInternational ();
           InvalidateRect (hwnd, NULL, TRUE);
           return (0);

      //----------------------------------------------------------------------//
      // beim beenden des Programms schn den Timer wieder entfernen...       //
      //----------------------------------------------------------------------//
      case WM_DESTROY :
           KillTimer (hwnd, ID_TIMER);
           PostQuitMessage (0);
           return (0);
   }
   return DefWindowProc (hwnd, message, wParam, lParam);
}