//****************************************************************************//
//   P6e.cpp - Freier Speicherplatz                                           //
//****************************************************************************//

#include <windows.h>
#include <stdio.h>

#define ID_TIMER    1

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunction, die die Messages der Client-Area verarbeitet //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
	static char szWindowclassname[] = "P6e";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWndclass;

   if (hPrevInstance) return (FALSE);

   aWndclass.style         = CS_HREDRAW | CS_VREDRAW;
   aWndclass.lpfnWndProc   = WndProc;
   aWndclass.cbClsExtra    = 0;
   aWndclass.cbWndExtra    = 0;
   aWndclass.hInstance     = hInstance;
   aWndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
   aWndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
   aWndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
   aWndclass.lpszMenuName  = NULL;
   aWndclass.lpszClassName = szWindowclassname;

   RegisterClass (&aWndclass);

   hWindow = CreateWindow (szWindowclassname, "Freier Speicher",
                           WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);

   //-------------------------------------------------------------------------//
   // mit der Funktion SetTimer kann man bei Windows den Wunsch anmelden, da //
   // Windows in bestimmten Zeitintervallen eine genau definierte Message     //
   // schicken soll                                                           //
   //-------------------------------------------------------------------------//
   if (!SetTimer (hWindow, ID_TIMER, 500, NULL))
   {
      //----------------------------------------------------------------------//
		// MessageBox ist eine sehr einfache und ntzliche Funktion, um dem An- //
      // wender Hinweise bzw. Fehlermeldungen zukommen zu lassen....          //
      //----------------------------------------------------------------------//
      MessageBox (hWindow, "Zuviele Timer!", szWindowclassname,
                             MB_ICONEXCLAMATION | MB_OK);
      return FALSE;
   }

   //-------------------------------------------------------------------------//
   // Programm als Icon (Taskbar) starten                                     //
   //-------------------------------------------------------------------------//
	ShowWindow   (hWindow, SW_MINIMIZE);
   UpdateWindow (hWindow);

   while (GetMessage (&aMessage, NULL, 0, 0))
   {
	   TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return (aMessage.wParam);
}


//----------------------------------------------------------------------------//
// Handlerfunction fr Client-Area                                            //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   MEMORYSTATUS ms;
   static DWORD  dwFreeMem;
   char          cBuffer [20];

   switch (message)
   {
      //----------------------------------------------------------------------//
		// Bei jedem Timeraufruf den Titel des Programms ndern und darin den   //
      // freien Speicherplatz darstellen                                      //
      //----------------------------------------------------------------------//
      case WM_TIMER :
           // dwFreeMem = GetFreeSpace (0);
			  GlobalMemoryStatus (&ms);
           sprintf (cBuffer, "%.ld",ms.dwAvailPhys);
           SetWindowText (hwnd, cBuffer);
           return (0);


      //----------------------------------------------------------------------//
		// Ein Vergrern des Programms nicht zulassen                          //
      //----------------------------------------------------------------------//
      case WM_QUERYOPEN :
           return (0);

      //----------------------------------------------------------------------//
		// Beenden des Programms (Timer freigeben)                              //
      //----------------------------------------------------------------------//
      case WM_DESTROY :
           KillTimer (hwnd, ID_TIMER);
           PostQuitMessage (0);
           return (0);
   }
   return DefWindowProc (hwnd, message, wParam, lParam);
}
