//****************************************************************************//
//   P7.cpp - Kontrollelemente-Demo                                           //
//****************************************************************************//
#include <windows.h>
#include <stdlib.h>
#include <string.h>

#define  MAXENV  4096
#define  MYLISTBOX1 1L
#define  MYSTATTXT1 2L

//----------------------------------------------------------------------------//
// Prototyp der Handlerfunction, die die Messages der Client-Area verarbeitet //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
	static char szWindowclassname[] = "P7";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWndclass;

   if (!hPrevInstance)
   {
   	aWndclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWndclass.lpfnWndProc   = WndProc;
      aWndclass.cbClsExtra    = 0;
      aWndclass.cbWndExtra    = 0;
      aWndclass.hInstance     = hInstance;
      aWndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
	   aWndclass.lpszMenuName  = NULL;
      aWndclass.lpszClassName = szWindowclassname;

      RegisterClass (&aWndclass);
	}

   hWindow = CreateWindow (szWindowclassname, "Kontrollelemente-Demo",
                           WS_OVERLAPPEDWINDOW | WS_VSCROLL | WS_HSCROLL,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);

	ShowWindow (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   while (GetMessage (&aMessage, NULL, 0, 0))
   {
	   TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Messagehandler der Client-Area                                             //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   static char szBuffer [MAXENV + 1];
   static HWND hwndList, hwndText;
   HDC         hdc;
   TEXTMETRIC  tm;
   WORD        n;
   WORD        wID;
   LRESULT     lAnz;

   switch (message)
   {
		//----------------------------------------------------------------------//
      // Initialisierung bei Erzeugung des Fensters                           //
		//----------------------------------------------------------------------//
      case WM_CREATE :
           hdc = GetDC (hwnd);
      	  //-----------------------------------------------------------------//
           // Eigenschaften (Mae) des Standardfonts ernitteln                //
      	  //-----------------------------------------------------------------//
           GetTextMetrics (hdc, &tm);
           ReleaseDC (hwnd, hdc);

      	  //-----------------------------------------------------------------//
           // Wir erzeugen uns eine Listbox, auch diese ist "nur" ein Fenster //
           // dh. hier ein Child der Client-Area                              //
           // Da ein Child kein Men haben kann, wird wieder das Menu-Handle  //
           // als ID-Nummer mibraucht (siehe DEFINE)                         //
           // Alle Listbox-Eigenschaften beginnen mit LBS_ (ListBoxStyle...)  //
      	  //-----------------------------------------------------------------//
           hwndList = CreateWindow ("listbox", NULL,
                      WS_CHILD | WS_VISIBLE | LBS_STANDARD,
                      tm.tmAveCharWidth,
                      tm.tmHeight * 3,
                      tm.tmAveCharWidth * 30 + GetSystemMetrics (SM_CXVSCROLL),
                      tm.tmHeight * 7,
                      hwnd, (HMENU)MYLISTBOX1,
                      (LPVOID)GetWindowLong (hwnd, GWL_HINSTANCE), NULL);

      	  //-----------------------------------------------------------------//
           // Erzeugung eines "Statisches Textfeldes". Auf diesem Feld kann   //
           // nur vom Programm aus ausgegeben werden, Eingaben sind nicht     //
           // mglich                                                         //
           // Alle Statictext-Eigenschaften beginnen mit SS_ (StaticString..) //
      	  //-----------------------------------------------------------------//
           hwndText = CreateWindow ("static", NULL,
                      WS_CHILD | WS_VISIBLE | SS_LEFT,
                      tm.tmAveCharWidth,
                      tm.tmHeight,
                      tm.tmAveCharWidth * MAXENV, tm.tmHeight,
                      hwnd, (HMENU)MYSTATTXT1,
                      (LPVOID)GetWindowLong (hwnd, GWL_HINSTANCE), NULL);

      	  //-----------------------------------------------------------------//
			  // ENVIRON ist eine syystemweites, globales Variablenfeld (char *) //
      	  //-----------------------------------------------------------------//
           for (n = 0; environ[n]; n++)
           {
          	  //--------------------------------------------------------------//
              // Wenn der String zu lang ist, dann machen wir einfach mit dem //
              // nchsten Eintrag weiter, ansonsten kopieren wir ihn auf den  //
              // Pufferstring und schneiden den zugewiesenen Inhalt der ENV   //
              // variablen in unserer Kopie ab. Den Namen der ENV-Variablen   //
              // fgen wir dann unserer Listbox hinzu                         //
          	  //--------------------------------------------------------------//
              if (strlen (environ [n]) > MAXENV) continue;
              *strchr (strcpy (szBuffer, environ [n]), '=') = '\0';
              SendMessage (hwndList, LB_ADDSTRING, 0, (LONG) (LPSTR) szBuffer);
           }
           return (0);

		//----------------------------------------------------------------------//
      // Das Fenster erhlt eine WM_SETFOCUS-Message, wenn es vom Anwender    //
      // oder vom System aktiviert wird                                       //
		//----------------------------------------------------------------------//
      case WM_SETFOCUS :
           SetFocus (hwndList);
           SendMessage (hwndList, LB_SETCURSEL, 2, 0L);
           SendMessage (hwnd, WM_COMMAND, MAKEWPARAM (MYLISTBOX1,LBN_SELCHANGE),
                        (LPARAM)hwndList);
           return (0);

		//----------------------------------------------------------------------//
      // Ein Programm erhlt eine WM_COMMAND-Message, jedesmal, wenn mit      //
      // einem der Dialogelemente etwas geschieht. ALLE Dialogelemente eines  //
      // werden ber diese eine COMMAND-Anweisung behandelt.                  //
		//----------------------------------------------------------------------//
      case WM_COMMAND :
		     //-----------------------------------------------------------------//
   	     // Um auf das Ereignis (Message) zu reagieren, mu man zunchst    //
      	  // ermitteln, mit welchem Dialogelement das gemeldete Ereignis in  //
      	  // Verbindung steht. Dazu mu man zunchst die ID-Nummer (siehe    //
      	  // DEFINE) aus dem wParam herausholen, sie steht im Low-Word       //
			  //-----------------------------------------------------------------//
           switch (LOWORD(wParam))
           {
			     //--------------------------------------------------------------//
              // Wenn man wei, mit welchem Dialogelement gerade etwas ge-    //
              // schehen ist, mu man ermitteln, ob einen das gemeldete Ereig-//
              // nis berhaupt interessiert. Die Art des Ereignisses, der so- //
              // genannte NOTIFY-Code, steht im High-Word von wParam          //
              // der lParam dient ggf. zum Transporrt weiterer Informationen  //
              // falls die Art des Ereignisses dies ntig macht.              //
              //--------------------------------------------------------------//
           	  case MYLISTBOX1 :
             		 //---------------------------------------------------------//
             		 // Der einzige Fall der uns hier interessiert, ist, da    //
                   // der Anwender ein neues Element in der Listbox angewhlt //
                   // hat. Dies meldet Windows mit dem Notify-Code            //
                   // LB_SELCHANGE (ListBox_SELectionCHANGEd)                 //
                   //---------------------------------------------------------//
                   if (HIWORD (wParam) == LBN_SELCHANGE)
                   {
                      //------------------------------------------------------//
							 // Da der Anwender eine ENV-Variable ausgewhlt hat,    //
                      // wollen wir jetzt den zugehrigen Inhalt im ober      //
                      // erzeugten STATICTEXT ausgeben. Dazu brauchen wir zu  //
                      // zunchst den Namen der in der Listbox ausgewhlten   //
                      // Variablen. Dazu gibt es die Mglichkeit, der LISTBOX //
                      // die Message LB_GETTEXT zu senden. Diese Message      //
                      // bentigt aber den Index der zurckzugebenden Text-   //
                      // zeile aus der Box, denn LB_GETTEXT kann unabhngig   //
                      // vom ausgewhlten Element aufgerufen werden. Der      //
                      // Index des Textes wird der Box im wParam bergeben.   //
                      // Auerdem erwartet die Listbox den Zeiger einer       //
                      // Stringvariablen, in die der Text kopiert wird (wird  //
                      // im lParam bergeben).                                //
                      // Uns fehlt also noch der Index des ausgewhlten LB-   //
                      // elements, welcher aber ber die Message LB_GETCURSEL //
                      // (ListBox_GETCURrentSELected) beschafft werden kann   //
                      //------------------------------------------------------//
                      n = (WORD) SendMessage (hwndList, LB_GETCURSEL, 0, 0L);

                      //------------------------------------------------------//
                      // Praktischerweise gibt die Message LG_GETTEXT die     //
                      // Lnge des kopierten Textes zurck....                //
                      //------------------------------------------------------//
                      n = (WORD) SendMessage (hwndList, LB_GETTEXT, n,
                                              (LONG)(LPSTR)szBuffer);
                      //------------------------------------------------------//
                      // and den Namen der ENV-Variablen hngen wir nun den   //
                      // zugehrigen Inhalt an, der ber die Standardfunction //
                      // getenv ermittelt werden kann...                      //
                      //------------------------------------------------------//
                      strcpy (szBuffer + n + 1, getenv (szBuffer));
                      *(szBuffer + n) = '=';

                      //------------------------------------------------------//
                      // SetWindowText setzt den Beschreibungstext eines Dia- //
                      // logelementes. Da STATIC-Texte nur aus diese Be-      //
                      // schreibung bestehen, haben wir damit unser Ziel be-  //
                      // reits erreicht...                                    //
                      //------------------------------------------------------//
                      SetWindowText (hwndText, szBuffer);
                   }
                   break;

              //--------------------------------------------------------------//
              // Ein COMMAND zu MYSTATTXT1 kann nicht vorkommen, und dient    //
              // hier nur zur Veranschaulichung, wie mehrere Dialogelemente   //
              // mit einem COMMAND behandelt werden                           //
              //--------------------------------------------------------------//
              case MYSTATTXT1 :
                   break;
           }
           return (0);

		//----------------------------------------------------------------------//
      // Message, wenn das Programm beendet werden soll                       //
		//----------------------------------------------------------------------//
      case WM_DESTROY :
           PostQuitMessage (0);
           return 0;
   }
   return DefWindowProc (hwnd, message, wParam, lParam);
}
