//****************************************************************************//
//   P8.cpp - Dateiverwaltungs-Demo                                           //
//****************************************************************************//
#include <windows.h>
#include <io.h>
#include <string.h>
#include <direct.h>

#define  MAXREAD    8192
#define  MYLISTBOX1 1L
#define  MYSTATTXT1 2L

//----------------------------------------------------------------------------//
// Prototypen der Handlerfunktionen                                           //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc  (HWND, UINT, UINT, LONG);
long FAR PASCAL _export ListProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// globale Variablen                                                          //
//----------------------------------------------------------------------------//
FARPROC lpfnOldList;

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
	static char szWindowclassname[] = "P8";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWndclass;

   if (!hPrevInstance)
   {
   	aWndclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWndclass.lpfnWndProc   = WndProc;
      aWndclass.cbClsExtra    = 0;
      aWndclass.cbWndExtra    = 0;
      aWndclass.hInstance     = hInstance;
      aWndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	   aWndclass.lpszMenuName  = NULL;
      aWndclass.lpszClassName = szWindowclassname;

      RegisterClass (&aWndclass);
	}

   hWindow = CreateWindow (szWindowclassname, "Dateiverwaltung-Demo",
                           WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);

	ShowWindow (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   while (GetMessage (&aMessage, NULL, 0, 0))
   {
	   TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Messagehandler der Client-Area                                             //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   static BOOL     bValidFile;
   static char     sReadBuffer [MAXREAD];
   static char     szFile [16];
   static HWND     hwndList, hwndText;
   static OFSTRUCT ofs;
   static RECT     rect;
   char            szBuffer [MAXPATH + 1];
   HDC             hdc;
   int             iHandle, i;
   PAINTSTRUCT     ps;
   TEXTMETRIC      tm;

   switch (message)
   {
		//----------------------------------------------------------------------//
      // Initialisierung bei Erzeugung des Fensters                           //
		//----------------------------------------------------------------------//
      case WM_CREATE :
           hdc = GetDC (hwnd);
      	  //-----------------------------------------------------------------//
           // Eigenschaften (Mae) des Standardfonts ernitteln                //
      	  //-----------------------------------------------------------------//
           SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT));
           GetTextMetrics (hdc, &tm);
           ReleaseDC (hwnd, hdc);
           rect.left = 40 * tm.tmAveCharWidth;
           rect.top  =  3 * tm.tmHeight;
      	  //-----------------------------------------------------------------//
           // Wir erzeugen uns eine Listbox, auch diese ist "nur" ein Fenster //
           // dh. hier ein Child der Client-Area                              //
      	  //-----------------------------------------------------------------//
           hwndList = CreateWindow ("listbox", NULL,
                      WS_CHILDWINDOW | WS_VISIBLE | LBS_STANDARD,
                      tm.tmAveCharWidth,
                      tm.tmHeight * 3,
                      tm.tmAveCharWidth * 30 + GetSystemMetrics (SM_CXVSCROLL),
                      tm.tmHeight * 10,
                      hwnd, (HMENU)MYLISTBOX1,
                      (HANDLE)GetWindowLong (hwnd, GWL_HINSTANCE),
                      NULL);

      	  //-----------------------------------------------------------------//
           // Erzeugung eines "Statisches Textfeldes". Auf diesem Feld kann   //
           // nur vom Programm aus ausgegeben werden, Eingaben sind nicht     //
           // mglich                                                         //
      	  //-----------------------------------------------------------------//
           hwndText = CreateWindow ("static", getcwd (szBuffer, MAXPATH),
                      WS_CHILDWINDOW | WS_VISIBLE | SS_LEFT,
                      tm.tmAveCharWidth,
                      tm.tmHeight,
                      tm.tmAveCharWidth * MAXPATH,
                      tm.tmHeight,
                      hwnd, (HMENU)MYSTATTXT1,
                      (HANDLE)GetWindowLong (hwnd, GWL_HINSTANCE),
                      NULL);

      	  //-----------------------------------------------------------------//
			  // Als Child des Hauptfensters hngt die Listbox automatisch an    //
           // dessen Handler, dies wollen wir ndern. Da wir den bisherigen   //
           // Handler als Default-Handler angeben wollen, merken wir uns die  //
           // Adresse des Handlers                                            //
      	  //-----------------------------------------------------------------//
           lpfnOldList = (FARPROC) GetWindowLong (hwndList, GWL_WNDPROC);

      	  //-----------------------------------------------------------------//
           // Jetzt tragen wir den neuen Handler ein                          //
      	  //-----------------------------------------------------------------//
           SetWindowLong (hwndList, GWL_WNDPROC,
                          (LONG) MakeProcInstance ((FARPROC) ListProc,
                          GetWindowWord (hwnd, GWW_HINSTANCE)));

      	  //-----------------------------------------------------------------//
           // Mit LB_DIR lassen wir Windows die Listbox mit dem Verzeichnis   //
           // fllen                                                          //
      	  //-----------------------------------------------------------------//
           SendMessage (hwndList, LB_DIR, 0x37, (LONG) (LPSTR) "*.*");
           return (0);

		//----------------------------------------------------------------------//
      // Vernderung der Fenstergre                                         //
		//----------------------------------------------------------------------//
      case WM_SIZE :
           rect.right  = LOWORD (lParam);
           rect.bottom = HIWORD (lParam);
           return (0);

		//----------------------------------------------------------------------//
      // Das Fenster erhlt eine WM_SETFOCUS-Message, wenn es vom Anwender    //
      // oder vom System aktiviert wird                                       //
		//----------------------------------------------------------------------//
      case WM_SETFOCUS :
           SetFocus (hwndList);
           return (0);

		//----------------------------------------------------------------------//
      // Ein Programm erhlt eine WM_COMMAND-Message, jedesmal, wenn mit      //
      // einem der Dialogelemente etwas geschieht. ALLE Dialogelemente eines  //
      // werden ber diese eine COMMAND-Anweisung behandelt.                  //
		//----------------------------------------------------------------------//
      case WM_COMMAND :
  		     //-----------------------------------------------------------------//
   	     // Um auf das Ereignis (Message) zu reagieren, mu man zunchst    //
      	  // ermitteln, mit welchem Dialogelement das gemeldete Ereignis in  //
      	  // Verbindung steht. Dazu mu man zunchst die ID-Nummer (siehe    //
      	  // DEFINE) aus dem wParam herausholen, sie steht im Low-Word       //
			  //-----------------------------------------------------------------//
           switch (LOWORD(wParam))
           {
			     //--------------------------------------------------------------//
              // Wenn man wei, mit welchem Dialogelement gerade etwas ge-    //
              // schehen ist, mu man ermitteln, ob einen das gemeldete Ereig-//
              // nis berhaupt interessiert. Die Art des Ereignisses, der so- //
              // genannte NOTIFY-Code, steht im High-Word von wParam          //
              // der lParam dient ggf. zum Transporrt weiterer Informationen  //
              // falls die Art des Ereignisses dies ntig macht.              //
              //--------------------------------------------------------------//
           	  case MYLISTBOX1 :
             		 //---------------------------------------------------------//
                   // uns interessiert der Doppelclick auf einen Eintrag      //
             		 //---------------------------------------------------------//
                   if (HIWORD (wParam) == LBN_DBLCLK)
                   {
             		    //------------------------------------------------------//
                      // Index des doppelgecklickten Eintrags holen           //
             		    //------------------------------------------------------//
                      i = (WORD)(SendMessage (hwndList, LB_GETCURSEL, 0, 0L));
                      if (LB_ERR == i) break;

             		    //------------------------------------------------------//
                      // Text  des doppelgecklickten Eintrags holen           //
             		    //------------------------------------------------------//
                      SendMessage (hwndList, LB_GETTEXT, i,
                                   (LONG)(char far *)szBuffer);

             		    //------------------------------------------------------//
                      // Versuch diese Datei zu ffnen                        //
             		    //------------------------------------------------------//
                      i = OpenFile (szBuffer, &ofs, OF_EXIST | OF_READ);

             		    //------------------------------------------------------//
                      // Wenn das klappt, ist i ungleich -1                   //
             		    //------------------------------------------------------//
                      if (-1 != i)
                      {
              		       //---------------------------------------------------//
                         // Den Namen der Datei im Static-Text ausgeben       //
             		       //---------------------------------------------------//
                         bValidFile = TRUE;
                         strcpy (szFile, szBuffer);
                         getcwd (szBuffer, MAXPATH);
                         if (szBuffer [strlen (szBuffer) - 1] != '\\')
                              strcat (szBuffer, "\\");
                         SetWindowText (hwndText, strcat (szBuffer, szFile));
                      }
             		    //------------------------------------------------------//
                      // Wenn das nicht klappt ist i gleich -1                //
             		    //------------------------------------------------------//
                      else
                      {
              		       //---------------------------------------------------//
                         // Wir gehen mal davon aus, da es dann ein Ver-     //
                         // zeichnis sein mu und wechseln selbiges           //
             		       //---------------------------------------------------//
                         bValidFile = FALSE;
                         szBuffer [strlen (szBuffer) - 1] = '\0';

              		       //---------------------------------------------------//
                         // Verzeichniswechsel und Verz.-Namen anzeigen       //
             		       //---------------------------------------------------//
                         chdir (szBuffer + 1);
                         getcwd (szBuffer, MAXPATH);
                         SetWindowText (hwndText, szBuffer);

              		       //---------------------------------------------------//
                         // Inhalt der Listbox zurcksetzen und neu lesen     //
             		       //---------------------------------------------------//
                         SendMessage (hwndList, LB_RESETCONTENT, 0, 0L);
                         SendMessage (hwndList, LB_DIR, 0x37,
                                      (LONG) (LPSTR) "*.*");
                      }
                      InvalidateRect (hwnd, NULL, TRUE);
                   }
           }
           return 0;

		//----------------------------------------------------------------------//
      // Neu zeichnen                                                         //
		//----------------------------------------------------------------------//
      case WM_PAINT :
           hdc = BeginPaint (hwnd, &ps);
  		     //-----------------------------------------------------------------//
           // Font, Stiftfarbe und Hintergrund gem Standardeinstellungen    //
  		     //-----------------------------------------------------------------//
           SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT));
           SetTextColor (hdc, GetSysColor (COLOR_WINDOWTEXT));
           SetBkColor   (hdc, GetSysColor (COLOR_WINDOW));

  		     //-----------------------------------------------------------------//
           // Wenn es sich um eine Datei handelt, ist bValid auf TRUE gesetzt //
  		     //-----------------------------------------------------------------//
           iHandle = OpenFile (szFile, &ofs, OF_REOPEN | OF_READ);
           if ((bValidFile && -1) != iHandle)
           {
              i = _lread (iHandle, sReadBuffer, MAXREAD);
              _lclose (iHandle);
              DrawText (hdc, sReadBuffer, i, &rect,
                        DT_WORDBREAK | DT_EXPANDTABS | DT_NOCLIP | DT_NOPREFIX);
           }
           else
           {
              bValidFile = FALSE;
           }

           EndPaint (hwnd, &ps);
           return (0);

		//----------------------------------------------------------------------//
      // Programm beenden                                                     //
		//----------------------------------------------------------------------//
      case WM_DESTROY :
           PostQuitMessage (0);
           return (0);
   }
   return DefWindowProc (hwnd, message, wParam, lParam);
}

//----------------------------------------------------------------------------//
// Messagehandler der Listbox                                                 //
//----------------------------------------------------------------------------//
long FAR PASCAL _export ListProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   if ((message == WM_KEYDOWN) && (wParam == VK_RETURN))
   {
   //16bit: SendMessage(GetParent(hwnd),WM_COMMAND,1,MAKELONG(hwnd,LBN_DBLCLK));
      SendMessage(GetParent(hwnd),WM_COMMAND,MAKELONG(1,LBN_DBLCLK),(long)hwnd);
   }
   return CallWindowProc (lpfnOldList, hwnd, message, wParam, lParam);
}

