//****************************************************************************//
//   P9.cpp - Farbmischung                                                    //
//****************************************************************************//
#include <windows.h>
#include <stdlib.h>

inline int min (int a, int b) { if (a < b) return (a); else return (b); }
inline int max (int a, int b) { if (a > b) return (a); else return (b); }

//----------------------------------------------------------------------------//
// Prototypen der Handlerfunktionen                                           //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc    (HWND, UINT, UINT, LONG);
long FAR PASCAL _export ScrollProc (HWND, UINT, UINT, LONG);

//----------------------------------------------------------------------------//
// globale Variablen                                                          //
//----------------------------------------------------------------------------//
FARPROC lpfnOldScr[3];
HWND    hwndScrol[3], hwndLabel[3], hwndValue[3], hwndRect;
int     color[3], nFocus;

HWND    hWindow;

//----------------------------------------------------------------------------//
// Alle Windowsprogramme beginnen mit "WinMain" statt mit "main"              //
//----------------------------------------------------------------------------//
#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine,
                    int nCmdShow)
{
	static char szWindowclassname[] = "P9";
   static char *szColorLabel[] = { "Rot", "Grn", "Blau" };
   MSG         aMessage;
   WNDCLASS    aWndclass;
   FARPROC     lpfnScrollProc;
   short       n;

   if (hPrevInstance) return FALSE;

   aWndclass.style         = CS_HREDRAW | CS_VREDRAW;
   aWndclass.lpfnWndProc   = WndProc;
   aWndclass.cbClsExtra    = 0;
   aWndclass.cbWndExtra    = 0;
   aWndclass.hInstance     = hInstance;
   aWndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
   aWndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
   aWndclass.hbrBackground = CreateSolidBrush (0L);
   aWndclass.lpszMenuName  = NULL;
   aWndclass.lpszClassName = szWindowclassname;

   RegisterClass (&aWndclass);

   hWindow = CreateWindow (szWindowclassname, "Farbmischung-Demo",
                           WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);

   //-------------------------------------------------------------------------//
   // Rechteck zum anzeigen der Farbe erzeugen, wir mibrauchen dafr ein     //
   // leeres STATIC-Control                                                   //
   //-------------------------------------------------------------------------//
   hwndRect = CreateWindow ("static", NULL,
                            WS_CHILD | WS_VISIBLE | SS_WHITERECT,
                            0, 0, 0, 0,
                            hWindow, (HMENU)9, hInstance, NULL);

   //-------------------------------------------------------------------------//
   // Adresse des eigenen Handlers fr die drei Scrollbars ermitteln          //
   //-------------------------------------------------------------------------//
   lpfnScrollProc = MakeProcInstance ((FARPROC) ScrollProc, hInstance);

   //-------------------------------------------------------------------------//
   // die drei Scrollbars mit berschrift und Nummernanzeige                  //
   //-------------------------------------------------------------------------//
   for (n=0; n<3; n++)
   {
      //----------------------------------------------------------------------//
      // Scrollbar                                                            //
      //----------------------------------------------------------------------//
      hwndScrol[n] = CreateWindow ("scrollbar", NULL,
                     WS_CHILD | WS_VISIBLE | WS_TABSTOP | SBS_VERT,
                     0, 0, 0, 0,
                     hWindow, (HMENU)n, hInstance, NULL);

      //----------------------------------------------------------------------//
      // berschrift                                                          //
      //----------------------------------------------------------------------//
      hwndLabel[n] = CreateWindow ("static", szColorLabel[n],
                     WS_CHILD | WS_VISIBLE | SS_CENTER,
                     0, 0, 0, 0,
                     hWindow, (HMENU)(n+3), hInstance, NULL);

      //----------------------------------------------------------------------//
      // Flche hinter des Scrollbars (bleibt farblich konstant)              //
      //----------------------------------------------------------------------//
      hwndValue[n] = CreateWindow ("static", "0",
                     WS_CHILD | WS_VISIBLE | SS_CENTER,
                     0, 0, 0, 0,
                     hWindow, (HMENU)(n+6), hInstance, NULL);

      //----------------------------------------------------------------------//
      // Eintragen des eigenen Scrollbarhandlers und sichern der alten        //
      // Scrollbar-Handleradresse                                             //
      //----------------------------------------------------------------------//
      lpfnOldScr[n] = (FARPROC) GetWindowLong (hwndScrol[n], GWL_WNDPROC);
      SetWindowLong  (hwndScrol[n], GWL_WNDPROC, (LONG) lpfnScrollProc);

      //----------------------------------------------------------------------//
      // Scrollbar-Eingabebereich auf 0-255 setzen und mit 0 initialisieren   //
      //----------------------------------------------------------------------//
      SetScrollRange (hwndScrol[n], SB_CTL, 0, 255, FALSE);
      SetScrollPos   (hwndScrol[n], SB_CTL, 0, FALSE);
   }

	ShowWindow (hWindow, nCmdShow);
   UpdateWindow (hWindow);

   while (GetMessage (&aMessage, NULL, 0, 0))
   {
	   TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return (aMessage.wParam);
}

//----------------------------------------------------------------------------//
// Handlerfunktion fr die Client-Area                                        //
//----------------------------------------------------------------------------//
long FAR PASCAL _export WndProc (HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   static HBRUSH hBrush[3];
   HBRUSH        newBrush;
   HGDIOBJ       hObject;
   char          szbuffer[10];
   HDC           hdc;
   POINT         point;
   int           n, cxClient, cyClient, cyChar;
   TEXTMETRIC    tm;

   switch (message)
   {
      //----------------------------------------------------------------------//
      // Beim Erzeigen des Fensters drei Brushes erzeugen (dynamisch) fr die //
      // Grundfarben hinter den Scrollbars                                    //
      //----------------------------------------------------------------------//
      case WM_CREATE :
           hBrush[0] = CreateSolidBrush (RGB (255, 0, 0));
           hBrush[1] = CreateSolidBrush (RGB (0, 255, 0));
           hBrush[2] = CreateSolidBrush (RGB (0, 0, 255));
           return (0);

      //----------------------------------------------------------------------//
      // Bei Vernderung der Fenstergre                                     //
      //----------------------------------------------------------------------//
      case WM_SIZE :
           //-----------------------------------------------------------------//
           // Die neue Fenstergre ermitteln                                 //
           //-----------------------------------------------------------------//
           cxClient = LOWORD (lParam);
           cyClient = HIWORD (lParam);

           //-----------------------------------------------------------------//
           // Texteinstellungen fr den Standardfont ermitteln                //
           //-----------------------------------------------------------------//
           hdc = GetDC (hwnd);
           GetTextMetrics (hdc, &tm);
           cyChar = tm.tmHeight;
           ReleaseDC (hwnd, hdc);

           //-----------------------------------------------------------------//
           // Rechteck hinter den Scrollbars neu skalieren                    //
           //-----------------------------------------------------------------//
           MoveWindow (hwndRect, 0, 0, cxClient / 2, cyClient, TRUE);
           for (n = 0; n < 3; n++)
           {
              //--------------------------------------------------------------//
              // Die drei Scrollbars neu positionieren und skalieren          //
              //--------------------------------------------------------------//
              MoveWindow (hwndScrol[n], (2*n+1)*cxClient/14, 2*cyChar,
                          cxClient/14, cyClient-4*cyChar, TRUE);
              MoveWindow (hwndLabel[n], (4*n+1)*cxClient/28, cyChar/2,
                          cxClient/7, cyChar, TRUE);
              MoveWindow (hwndValue[n], (4*n+1)*cxClient/28,cyClient-3*cyChar/2,
                          cxClient/7, cyChar, TRUE);
           }
           SetFocus (hwnd);
           return (0);

      //----------------------------------------------------------------------//
      // Bei Zuordnung des Eingabefocus                                       //
      //----------------------------------------------------------------------//
      case WM_SETFOCUS :
           SetFocus (hwndScrol[nFocus]);
           return (0);

      //----------------------------------------------------------------------//
      // Wenn einer der Scrollbars bedient wird                               //
      //----------------------------------------------------------------------//
      case WM_VSCROLL :
           //-----------------------------------------------------------------//
           // Id-Nummer des entsprechenden Objekts holen (liegt zw. 0 und 2)  //
           //-----------------------------------------------------------------//
           n = GetWindowLong ((HANDLE)lParam, GWL_ID);

           //-----------------------------------------------------------------//
           // Wie wurde das Scroll-Ereignis ausgelst ?                       //
           //-----------------------------------------------------------------//
           switch (LOWORD(wParam))
           {
              //--------------------------------------------------------------//
              // Seite herunter                                               //
              //--------------------------------------------------------------//
              case SB_PAGEDOWN :
                   color[n] += 15;
                   color[n] = min (255, color[n] + 1);
                   break;

              //--------------------------------------------------------------//
              // Zeile herunter                                               //
              //--------------------------------------------------------------//
              case SB_LINEDOWN :
                   color[n] = min (255, color[n] + 1);
                   break;

              //--------------------------------------------------------------//
              // Seite herauf                                                 //
              //--------------------------------------------------------------//
              case SB_PAGEUP :
                   color[n] -= 15;
                   color[n] = max (0, color[n] - 1);
                   break;

              //--------------------------------------------------------------//
              // Zeile herauf                                                 //
              //--------------------------------------------------------------//
              case SB_LINEUP :
                   color[n] = max (0, color[n] - 1);
                   break;

              //--------------------------------------------------------------//
              // Ganz nach oben                                               //
              //--------------------------------------------------------------//
              case SB_TOP :
                   color[n] = 0;
                   break;

              //--------------------------------------------------------------//
              // Ganz nach unten                                              //
              //--------------------------------------------------------------//
              case SB_BOTTOM :
                   color[n] = 255;
                   break;

              //--------------------------------------------------------------//
              // Schieben                                                     //
              //--------------------------------------------------------------//
              case SB_THUMBTRACK :
                   color[n] = HIWORD(wParam);
                   break;

              default :
                   break;
           }

           //-----------------------------------------------------------------//
           // Scrollbutton dem Wert entsprechend setzen                       //
           //-----------------------------------------------------------------//
           SetScrollPos  (hwndScrol[n], SB_CTL, color[n], TRUE);
           SetWindowText (hwndValue[n], itoa (color[n], szbuffer, 10));

           //-----------------------------------------------------------------//
           // Brush mit den neuen RGB-Werten erzeugen und als Hintergrund-    //
           // farbe des Fensters einsetzen. Anschlieend Brush wieder freige- //
           // ben und die Client-Area invalidieren                            //
           //-----------------------------------------------------------------//
           newBrush = CreateSolidBrush (RGB (color[0], color[1], color[2]));
           hObject=(HGDIOBJ)SetClassLong(hwnd,GCL_HBRBACKGROUND,(long)newBrush);
           DeleteObject (hObject);
           InvalidateRect (hwnd, NULL, TRUE);
           return (0);

      //----------------------------------------------------------------------//
      // Vernderung der Hintergrundfarbe der Scrollbars                      //
      //----------------------------------------------------------------------//
      // Achtung!!! unter 16-Bit-Anwendungen gibt es nicht eine Message pro   //
      // Objekttyp (hier SCROLLBAR), sondern nur eine allgemeine CTLCOLOR     //
      // Message. Der Objekttyp mu dann aus dem lParam ermittelt werden. Die //
      // CTLCOLOR-Message existiert im 32bit-Windows nicht mehr:              //
      //             case WM_CTLCOLOR :                                       //
      //                  if (HIWORD (lParam) == CTLCOLOR_SCROLLBAR)          //
      //----------------------------------------------------------------------//
      case WM_CTLCOLORSCROLLBAR :
           //-----------------------------------------------------------------//
           // Hintergrundfarbe fr Textausgabe aus Windowseinstellungen holen //
           // Vordergrundfarbe auch und dazu die ID-Nummer der Scrollbar      //
           //-----------------------------------------------------------------//
           SetBkColor ((HDC)wParam, GetSysColor (COLOR_CAPTIONTEXT));
           SetTextColor ((HDC)wParam, GetSysColor (COLOR_WINDOWFRAME));
           n = GetWindowLong ((HWND)lParam, GWL_ID);

           //-----------------------------------------------------------------//
           // Screenposition der Clientarea ermitteln                         //
           //-----------------------------------------------------------------//
           point.x = 0;
           point.y = 0;
           ClientToScreen (hwnd, &point);

           //-----------------------------------------------------------------//
           // Palette der Scrollbar neu berechnen lassen                      //
           // logische Startposition des Brushes (fr gerasterte) setzen      //
           //-----------------------------------------------------------------//
           UnrealizeObject (hBrush[n]);
           SetBrushOrgEx ((HDC)wParam, point.x, point.y, NULL);
           return ((DWORD) hBrush[n]);

      //----------------------------------------------------------------------//
      // Bei Programmende den Startzustand wiederherstellen                   //
      //----------------------------------------------------------------------//
      case WM_DESTROY :
               DeleteObject ((HGDIOBJ)SetClassLong (hwnd, GCL_HBRBACKGROUND,
                             (long)GetStockObject (WHITE_BRUSH)));
               for (n = 0; n < 3; DeleteObject (hBrush [n++]));
               PostQuitMessage (0);
               return (0);
          }
     return DefWindowProc (hwnd, message, wParam, lParam);
     }

//----------------------------------------------------------------------------//
// Handlerfunktion fr die Scrollbar                                          //
//----------------------------------------------------------------------------//
long FAR PASCAL _export ScrollProc (HWND hwnd, UINT message, UINT wParam,
                                    LONG lParam)
{
	//-------------------------------------------------------------------------//
   // ID-Nummer des Objektes holen, da dieser Handler fr alle drei Scroll-   //
   // bars benutzt wird                                                       //
	//-------------------------------------------------------------------------//
	static int n = GetWindowLong (hwnd, GWL_ID);
   static BOOL shiftisdown = FALSE;

   switch (message)
   {
      //----------------------------------------------------------------------//
      // Wenn eine Taste gedrckt wird, dann nachsehen, ob es Tab-Taste ist   //
      //----------------------------------------------------------------------//
      case WM_KEYDOWN :
           if (wParam == VK_TAB)
           {
              if (GetKeyState (VK_SHIFT) < 0) n = (n + 2) % 3;
              else n = (n + 1) % 3;
              SetFocus (hwndScrol[n]);
           }
           if (wParam == VK_SHIFT)
              shiftisdown = TRUE;
           break;

      case WM_KEYUP :
           if (wParam == VK_SHIFT)
              shiftisdown = FALSE;
           if (wParam == VK_UP)
           {
					if (shiftisdown)
                  SendMessage (hWindow, WM_VSCROLL,
                               SB_PAGEUP,
                               (LPARAM)hwndScrol[nFocus]);
             //  else
                //  SendMessage (hWindow, WM_VSCROLL,
                //  SB_LINEUP, );

           }
           return (1);

      case WM_SETFOCUS :
           nFocus = n;
           break;
   }
   return (CallWindowProc (lpfnOldScr[n], hwnd, message, wParam, lParam));
}
